//*****************************************
// AVR ATmega644A Serial Monitor-G
// CPU Clock:8MHz,16MHz,18.432MHz or 20MHz(Compile Option)
// File Name:AVR_ATmegae644_G_moni.c
// VAf[^iqrQRQbjj^[vO
//   iq[Yf[^@is`fgpȂAȂAwIV[^(16MHz)Aɂj
//   i`FbN͂rohdmj
//
// AVR_ATmega164_G_moni Ƃ̓n[h̐ڑႤ̂œւ͏oȂ
//
//
//  2013/05/26 New  Taishi ATmega644
//*****************************************

#include	<avr/interrupt.h>
#include	<avr/io.h>
#include	<avr/eeprom.h>
#include	<avr/sleep.h>
#include	<avr/pgmspace.h>

#include	"AVR_ATmega644_G_moni.h"
#include	"Serial.h"
#include	"Comm1.h"
#include	"Comm2.h"
#include	"LCD.h"
#include	"Display.h"
#include	"Setting.h"
#include	"EEPROM.h"
#include	"Utility.h"
#include	"Ad_conv.h"
#include	"timer.h"

unsigned char	str_title_1[] PROGMEM = {"Serial Monitor-G"};		// ^Cg|P
unsigned char	str_title_2[] PROGMEM = {"ATmega644"};				// ^Cg|Q
unsigned char	str_date[] PROGMEM = {__DATE__};					// 쐬@N
unsigned char	str_time[] PROGMEM = {__TIME__};					// 쐬@
unsigned char	str_crlf[] PROGMEM = {"\r\n"};						// CR + LF

//*****************************************
// kbcG[
//*****************************************
void	lcd_error(void)
{
	cli();

	for(;;){
		PORTA |=  (1 << PA6);
		PORTD |=  (1 << PD5);
		delay_ms(200);												// 200mS Delay
		PORTA &= ~(1 << PA6);
		PORTD &= ~(1 << PD5);
		delay_ms(200);												// 200mS Delay
	}
}

//*****************************************
// Mobt@[0][511]܂łꂢɕבւB
// i̕\̍lyɂׁj
//  LMf[^Zbg
//*****************************************
void	narabukae(void)
{
	static	unsigned int	r_e_d[N_of_RXD];						// Mf[^ꎞޔꏊ
	unsigned int			s_pos;
	unsigned int			i;

	if(n_of_receive == 0){											// MĂȂ
		n_of_valid_rxd = 0;
		s_pos = 0;
	}else{
		if(save_set_pass_time == CODE_PASS_TIME_ON){				// oߎԗL̎
			if(n_of_receive < (N_of_RXD / 2)){						// \܂ŎMĂȂ
				s_pos = 0;
				n_of_valid_rxd = n_of_receive;						// LMf[^ Mf[^
			}else{
				s_pos = (((write_data_pos - 0) - N_of_RXD) & DATA_POS_MASK);
				n_of_valid_rxd = (N_of_RXD / 2);					// LMf[^͎Mf[^obt@
			}
		}else{														// oߎԖ̎
			if(n_of_receive < N_of_RXD){							// \܂ŎMĂȂ
				s_pos = 0;
				n_of_valid_rxd = n_of_receive;						// LMf[^ Mf[^
			}else{
				s_pos = (((write_data_pos - 0) - N_of_RXD) & DATA_POS_MASK);
				n_of_valid_rxd = N_of_RXD;							// LMf[^͎Mf[^obt@
			}
		}
	}

	for(i=0;i<N_of_RXD;i++){
		r_e_d[i] = rxd_err_data[s_pos];								// Mf[^ႢɁ@ꎞޔꏊɃRs[
		s_pos++;
		s_pos &= DATA_POS_MASK;
	}

	for(i=0;i<N_of_RXD;i++){
		rxd_err_data[i] = r_e_d[i];									// ꎞޔꏊMf[^obt@ɖ߂
	}

}
//*****************************************
// Main
//*****************************************
int	main(void)
{
	signed char		disp_move_dir;
	unsigned int	bat_ad = 1023;

	PRR0 |= ((1 << PRTWI) | (1 << PRTIM0) | (1 << PRSPI));								// sṽNbN~

	disp_move_dir = 0;
	disp_end_pos = 0;
	DDRB &= ~((1 << DDB0) | (1 << DDB1) | (1 << DDB2) | (1 << DDB3) | (1 << DDB4));					// Port-B Bit0,1,2,3 & 4: Input(0,1,2,3,4 for Switch 1 -- 5)
	PORTB = ((1 << PB0) | (1 << PB1) | (1 << PB2) | (1 << PB3) | (1 << PB4));						// Port-B Bit0,1,2,3 & 4: Pullup
	DDRD = ((1 << DDD1) | (1 << DDD3) | (1 << DDD4) | (1 << DDD5) | (1 << DDD6) | (1 << DDD7) );	// Port-D Bit0 & 2:Input, other:Output
	DDRA = ((1 << DDA0) | (1 << DDA1) | (1 << DDA2) | (1 << DDA3) | (1 << DDA4) | (1 << DDA5) | (1 << DDA6));		// PA0--6:Output

	delay_ms(200);												// 200mS Delay



#ifdef		DEBUG_TX
	uart0_pre_init();											// UART Pre_Initial
	get_pgm_str(&str_crlf[0]);									// vÖ̕("\r\n")擾
	tx0_str(disp_moji);
	tx0_str(disp_moji);

	get_pgm_str(&str_title_1[0]);								// vÖ̕("Serial Monitor-G")擾
	tx0_str(disp_moji);

	get_pgm_str(&str_title_2[0]);								// vÖ̕("ATmega664")擾
	tx0_str(disp_moji);

	get_pgm_str(&str_date[0]);									// vÖ̕(N)擾
	tx0_str(disp_moji);

	get_pgm_str(&str_crlf[0]);									// vÖ̕("\r\n")擾
	tx0_str(disp_moji);

	get_pgm_str(&str_time[0]);									// vÖ̕()擾
	tx0_str(disp_moji);

	tx0_str((unsigned char *)"\r\n");
	get_pgm_str(&str_crlf[0]);									// vÖ̕("\r\n")擾
	tx0_str(disp_moji);
#endif		//DEBUG_TX

	init_lcd_G();
	disp_clear_lcd_G();

	load_setting_from_eeprom();									// ݒf[^ddoqnl擾
	back_light(set_back_light);									// Back Light ON/OFF

	get_pgm_str(&str_title_1[0]);								// vÖ̕("Serial Monitor-G")擾
	disp_lcd_G(0,0,disp_moji);									// \
	get_pgm_str(&str_title_2[0]);								// vÖ̕("ATmega664")擾
	disp_lcd_G(2,1,disp_moji);									// \
	get_pgm_str(&str_date[0]);									// vÖ̕(N)擾
	disp_lcd_G(0,2,disp_moji);									// \
	get_pgm_str(&str_time[0]);									// vÖ̕()擾
	disp_lcd_G(0,3,disp_moji);									// \

	ad7_init();													// A/D 7 Initial

	delay_ms(2000);												// 2000mS Delay

#ifdef		CHECK_FONT											// tHg`FbN\
// ****************** Font Check Start ******************
	for(;;){
		disp_clear_lcd_G();
		disp_lcd_G_font_check1();
		for(;;){
			if(((~PINB) & SW2) != 0){								// ]ăXCb`f[^擾
				delay_ms(30);										// 30mS Delay
				if(((~PINB) & SW2) != 0){							// ]ăXCb`f[^擾
					break;
				}
			}
		}
		for(;;){
			if(((~PINB) & SW2) == 0){								// ]ăXCb`f[^擾
				delay_ms(30);										// 30mS Delay
				if(((~PINB) & SW2) == 0){							// ]ăXCb`f[^擾
					break;
				}
			}
		}

		disp_clear_lcd_G();
		disp_lcd_G_font_check2();
		for(;;){
			if(((~PINB) & SW2) != 0){								// ]ăXCb`f[^擾
				delay_ms(30);										// 30mS Delay
				if(((~PINB) & SW2) != 0){							// ]ăXCb`f[^擾
					break;
				}
			}
		}
		for(;;){
			if(((~PINB) & SW2) == 0){								// ]ăXCb`f[^擾
				delay_ms(30);										// 30mS Delay
				if(((~PINB) & SW2) == 0){							// ]ăXCb`f[^擾
					break;
				}
			}
		}
	}
// ****************** Font Check End ********************
#endif		//CHECK_FONT


	disp_clear_lcd_G();

 	timer2_init();												// Timer2 Initial(10mS Interval Timer)
	set_setting_data();											// ݒf[^̐ݒ
	save_setting_to_eeprom();									// ݒf[^ddoqnlɕۑ


	uart0_init();												// UART0 Initial
	uart1_init();												// UART1 Initial

	load_rxd_from_eeprom();										// Mf[^ddoqnl擾

	old_data_get_run = data_get_run;
	timer1_init();												// Timer1 Initial

	set_sleep_mode(SLEEP_MODE_IDLE);							// X[vFACh[h

	sei();														// 荞݉
	// iv[v
	for(;;){

		// kdc_if[^^C~Oœ_j
		if(tim_led != 0){
			PORTA |= (1 << PA6);
		}else{
			PORTA &= ~(1 << PA6);
		}


		// kdc_iԂœ_^_Ł^j
		if( data_get_run == CODE_DATA_GET_END){											// Mf[^擾I̎
			PORTD &= ~(1 << PD5);
		}else if(data_get_run == CODE_DATA_GET_RUN){									// Mf[^擾
			PORTD |= (1 << PD5);
		}else if(data_get_run == CODE_DATA_GET_WAIT){									// gKf[^҂
			if(tim_run_led == 0){
				tim_run_led = 50;
				PORTD ^= (1 << PD5);
			}
		}


		//@XCb`
		get_sw();																		//@XCb`Ԃ
		if(sw[2] != 0){																	// ꂽXCb`L鎞
			if(((sw[2] & SW1) != 0)&&(sw[1] == SW1)){									// rP ( <-- )ꂽ
				if( data_get_run == CODE_DATA_GET_END){									// Mf[^擾I̎
					if(disp_start_pos <= 1){											// \擪@Mf[^擪̎
						;																// Ȃ
					}else{
						if(save_set_pass_time == CODE_PASS_TIME_ON){					// oߎԗL̎
							disp_start_pos -= n_of_one_line_disp_data_pass*2;			// sႢʒuɂ
						}else{															// oߎԖ̎
							disp_start_pos -= n_of_one_line_disp_data;					// sႢʒuɂ
						}
						if(disp_start_pos < 0){
							disp_start_pos = 0;
						}
						disp_one_block(disp_start_pos);									// disp_start_pos ɕ\s
						tim_disp = 80;
						disp_move_dir = -1;												// ֕\ړ
					}
				}
			}
			if(((sw[2] & SW2) != 0)&&(sw[1] == SW2)){									// rQ( ASC/HEX )ꂽ
				if( data_get_run == CODE_DATA_GET_END){									// Mf[^擾I̎
					if(n_of_valid_rxd == 0){											// 擾Mf[^O̎
						;																// Ȃ
					}else{
						disp_hex ^= 1;													// PUi\^`rbhh\̕ύX
						disp_one_block(disp_start_pos);									// disp_start_pos ɕ\s
					}
				}
			}
			if(((sw[2] & SW3) != 0)&&(sw[1] == SW3)){									// rR( --> )ꂽ
				if( data_get_run == CODE_DATA_GET_END){									// Mf[^擾I̎
					if(save_set_pass_time == CODE_PASS_TIME_ON){						// oߎԗL̎
						if( n_of_valid_rxd <= (disp_start_pos/2 + n_of_disp_data_pass) ){	// Ō̕\f[^ LMf[^ȏ̎
							;															// Ȃ
						}else{
							disp_start_pos += n_of_one_line_disp_data_pass*2;			// s̈ʒuɂ
							disp_one_block(disp_start_pos);								// disp_start_pos ɕ\s
							tim_disp = 80;
							disp_move_dir = 1;											// E֕\ړ
						}
					}else{																// oߎԖ̎
						if( n_of_valid_rxd <= (disp_start_pos + n_of_disp_data) ){		// Ō̕\f[^ LMf[^ȏ̎
							;															// Ȃ
						}else{
							disp_start_pos += n_of_one_line_disp_data;					// s̈ʒuɂ
							disp_one_block(disp_start_pos);								// disp_start_pos ɕ\s
							tim_disp = 80;
							disp_move_dir = 1;											// E֕\ړ
						}
					}
				}
			}
			if((sw[2] & SW4) != 0){														// rS(START/STOP)ꂽ
				disp_move_dir = 0;														// \̈ړ 
				if( data_get_run == CODE_DATA_GET_END){									// Mf[^擾I̎
					disp_clear_lcd_G();													// Clear Display
					if((sw[1] & (SW1 | SW2 | SW3)) == (SW1 | SW3)){						// rvPƂrvRĂ鎞ɂrvSꂽꍇ
						uart0_disable();												// UART0 Disable
						uart1_disable();												// UART1 Disable
						set_setting_data();												// ݒf[^̐ݒ
						save_setting_to_eeprom();										// ݒf[^ddoqnlɕۑ
						disp_clear_lcd_G();												// Clear Display
						disp_one_block(disp_start_pos);									// disp_start_pos ɕ\s
						uart0_init();													// UART0 Initial
						uart1_init();													// UART1 Initial
						tim_led = 50;
						sei();															// 荞݉
					}else{
						n_of_receive = 0;												// 擾Mf[^O
						write_data_pos = 0;
						rxd_rec = 0;
						disp_direction_signe_lcd_G();									// Direction Signe

						save_set_bps = set_bps;											// Mf[^̐ݒaorR[h̒l
						save_set_parity = set_parity;									// Mf[^̐ݒpeBR[h̒l
						save_set_data_length = set_data_length;							// Mf[^̃f[^R[h̒l
						save_set_end_less = set_end_less;								// Mf[^́@OFGhXAPFGhXłȂif[^obt@tɂȂ~j
						save_set_pass_time = set_pass_time;								// Mf[^̌oߎԂ̗L@OFoߎԖAPFoߎԗL
						save_trig_data = save_trig_data;								// Mf[^̃X^[ggK@̓GhgḰ@f[^
						pass_time_start();												// Passage time start
						if((set_end_less == CODE_STR_TRIG)||(set_end_less == CODE_TRIG_CYCL)){	// X^[ggK̎A̓X^[ggKňt܂ł̎
							data_get_run = CODE_DATA_GET_WAIT;							// Mf[^擾ɂ
						}else{
							data_get_run = CODE_DATA_GET_RUN;							// Mf[^擾ɂ
						}
						tim_disp = 10;
		 				old_data_get_run = data_get_run;
					}
				}else{																	// Mf[^擾IȊO̎
					data_get_run = CODE_DATA_GET_END;									// Mf[^擾Iɂ
					pass_time_stop();													// Passage Time stop
					if(n_of_receive == 0){												// 擾Mf[^
						disp_end_pos = 0;
					}else{
						disp_end_pos = 	((write_data_pos - 1) & DATA_POS_MASK);
					}

					if(n_of_receive < n_of_disp_data){									// \܂ŎMĂȂ
						first_pos_num = 1;
					}else if( n_of_receive < N_of_RXD){									// Mf[^Mf[^obt@ȉ̎
						first_pos_num = n_of_receive - (n_of_disp_data - 1);
					}else{																// Mf[^obt@ȏ̎
						first_pos_num = N_of_RXD - (n_of_disp_data - 1);
					}
				}
			}
			if((sw[2] & SW5) != 0){														// rT(SAVE)ꂽ
				if( data_get_run == CODE_DATA_GET_END){									// Mf[^擾I̎
					disp_move_dir = 0;													// \̈ړ 
					PORTD |= (1 << PD5);												// kdc_
					if((sw[1] & (SW1 | SW2 | SW3)) == (SW1 | SW3)){						// rvPƂrvRĂ鎞ɂrvTꂽꍇ
						tx_all_recieve_data();											// Transmit All Recieve Data
					}else{
						save_rxd_to_eeprom();											// Mf[^ddoqnlɕۑ
					}
					tim_led = 2;														// kdc_
				}
			}
		}
		
		// Mf[^\
		if( data_get_run == CODE_DATA_GET_END){											// Mf[^擾I̎
			if(tim_disp == 0){
				if(old_data_get_run != CODE_DATA_GET_END){								// ȑOMf[^擾IłȂi擾IɂȂuԁj

					narabukae();														// Mobt@[0][127]܂łꂢɕבւBi̕\̍lyɂׁj

					if(save_set_pass_time == CODE_PASS_TIME_ON){						// oߎԗL̎
						if(n_of_valid_rxd <= n_of_disp_data_pass){
							disp_start_pos = 0;
						}else{
							disp_start_pos = (n_of_valid_rxd * 2 - n_of_disp_data_pass * 2);
							disp_start_pos = ((disp_start_pos + (n_of_one_line_disp_data_pass - 1)*2) / (n_of_one_line_disp_data_pass*2)) * (n_of_one_line_disp_data_pass*2);
						}
					}else{																// oߎԖ̎
						if(n_of_valid_rxd <= n_of_disp_data){
							disp_start_pos = 0;
						}else{
							disp_start_pos = (n_of_valid_rxd - n_of_disp_data);
							disp_start_pos = ((disp_start_pos + (n_of_one_line_disp_data - 1)) / n_of_one_line_disp_data) * n_of_one_line_disp_data;
						}
					}
					disp_one_block(disp_start_pos);										// disp_start_pos ɕ\s
	 				old_data_get_run = data_get_run;
				}
				if((disp_move_dir == -1)&&((sw[1] & SW1) != 0)){						// \ړŃXCb`ꑱĂ
					if(disp_start_pos <= 1){											// \擪@Mf[^擪̎
						;																// Ȃ
					}else{
						if(save_set_pass_time == CODE_PASS_TIME_ON){					// oߎԗL̎
							disp_start_pos -= (n_of_one_line_disp_data_pass * 2);		// sႢʒuɂ
						}else{															// oߎԖ̎
							disp_start_pos -= n_of_one_line_disp_data;					// sႢʒuɂ
						}
						if(disp_start_pos < 0){
							disp_start_pos = 0;
						}
						disp_one_block(disp_start_pos);									// disp_start_pos ɕ\s
						tim_disp = 20;
					}
				}else if((disp_move_dir == 1)&&((sw[1] & SW3) != 0)){					// \EړŃXCb`ꑱĂ
					if(save_set_pass_time == CODE_PASS_TIME_ON){						// oߎԗL̎
						if( n_of_valid_rxd <= (disp_start_pos/2 + n_of_disp_data_pass) ){	// Ō̕\f[^ LMf[^ȏ̎
							;															// Ȃ
						}else{
							disp_start_pos += (n_of_one_line_disp_data_pass * 2);		// s̈ʒuɂ
							disp_one_block(disp_start_pos);								// disp_start_pos ɕ\s
							tim_disp = 20;
						}
					}else{																// oߎԖ̎
						if( n_of_valid_rxd <= (disp_start_pos + n_of_disp_data) ){		// Ō̕\f[^ LMf[^ȏ̎
							;															// Ȃ
						}else{
							disp_start_pos += n_of_one_line_disp_data;					// s̈ʒuɂ
							disp_one_block(disp_start_pos);								// disp_start_pos ɕ\s
							tim_disp = 20;
						}
					}
				}else{
					disp_move_dir = 0;													// \̈ړ 
				}
				old_data_get_run = data_get_run;
			}
		}else if(data_get_run == CODE_DATA_GET_RUN){									// Mf[^擾̎
			if(tim_disp == 0){
				tim_disp = 10;
				if(rxd_rec != 0){														// qwO͂qwPM
					rxd_rec = 0;
					disp_recieve_data();												// Mf[^\
				}else{
					if(save_set_pass_time == CODE_PASS_TIME_ON){						// oߎԗL̎
						disp_pass_time(11, 7);											// ݌oߎԕ\
					}
				}
			}
		}

		// obed
		if(tim_bat_ad == 0){
			tim_bat_ad = 100;
			bat_ad = ad7_get_data();													// A/D 7 Get (1V=3V)@obe|Ru̎͂XROɂȂ
			if(bat_ad < BAT_AD_MIN){													// Œdł
				icon_data ^= 0x08;														// dr}[N_
			}else{																		// Œdȏł
				icon_data &= ~0x08;														// dr}[N
			}
			disp_lcd_icon_G();															// display LCD Icon
		}
		
#ifdef		DEBUG_TX
		set_sleep_mode(SLEEP_MODE_IDLE);												// X[vFACh[h
#else		//DEBUG_TX
		if( data_get_run == CODE_DATA_GET_END){											// Mf[^擾I̎
			set_sleep_mode(SLEEP_MODE_EXT_STANDBY);										// X[vFgX^oC[h
		}else{
			set_sleep_mode(SLEEP_MODE_IDLE);											// X[vFACh[h
		}
#endif		//DEBUG_TX

		sleep_mode();																	// X[vڍs
	}

}

//*****************************************
// CR & LF Set to disp_moji[]
//*****************************************
void	get_cr_lf(void)
{
	get_pgm_str(&str_crlf[0]);									// vÖ̕("\r\n")擾
}
//*****************************************
// Title Set to disp_moji[]
//*****************************************
void	get_title(void)
{
	get_pgm_str(&str_title_1[0]);								// vÖ̕("Serial Monitor-G")擾
}
