//*****************************************
// AVR ATmega644 Serial Monitor-G
// CPU Clock:8MHz,16MHz,18.432MHz or 20MHz(Compile Option)
// File Name:Ad_conv.c
//  Use A/D Covertor
// KCK[JE^[p
//   iq[Yf[^@is`fgpȂAȂAwIV[^(8MHz)Aɂj
//   i`FbN͂rohdmj
//
//  PA7(ADC7): Battery Monitor Max. about 1V (1V = 3V)
//
//  2013/05/26 New  Taishi ATmega644
//*****************************************
#include				<avr/io.h>

#include				"AVR_ATmega644_G_moni.h"

#include				"Ad_conv.h"

unsigned int	ad7_data[N_of_AD_data];
unsigned char	ad7_count;
unsigned char	ad_conv_7;									// 0:ADC6 Convert Running, 1:ADC7 Convert running
// **********************************************************
// ************************* A/D 7 **************************
// **********************************************************

//*****************************************
// A/D 7 Initial
// @荞ݕs̏ԂŌĂ΂Ƃ
//  PA7(ADC7): Batter Monitor Max. about 1V (1V = 3V)
//*****************************************
void	ad7_init(void)
{
	unsigned char	i;


	ad7_count = 0;
	for(i = 0; i < N_of_AD_data; i++){
		ad7_data[i] = 0;
	}

	DIDR0 |= (1 << ADC7D);																	// AiO͐ݒ PD7

	ADMUX = ( (1 << REFS1) | (0 << REFS0) | (1 << MUX2) | (1 << MUX1) | (1 << MUX0) );		// PDPudgp, Select ADC7
	ADCSRA = ( (1 << ADEN) | (1 << ADSC) | (1 << ADPS2) | (1 << ADPS1) | (1 << ADPS0) );	// A/D, A/DϊJn, CK/128=8MHz/128=62.5kHz(16uS) --> 208uS
	ad_conv_7 = 1;																			// 1:ADC7 Convert running

}
//*****************************************
// A/D 7 close
//*****************************************
void	ad7_close(void)
{
	ADCSRA = 0;																				// A/Ds
	ad_conv_7 = 0;																			// 0:ADC7 Convert Not running
}
//*****************************************
// A/D 7 Set A/D data to Data Buffer
//  ϊIĂȂ́@Ȃ
//  POԊů荞݂ŌĂ΂
//*****************************************
void	ad7_set_data(void)
{
	if( (ADCSRA & (1 << ADIF)) != 0){								// `^cϊ
		ADCSRA |= (1 << ADIF);										// `^cϊtO폜
		if( ad_conv_7 != 0){										// ADC7 ϊ
			ad7_data[ad7_count] = ADCW;
			ad7_count++;
			ad7_count &= (N_of_AD_data - 1);
		}

		ADCSRA |= (1 << ADSC);										// A/DϊJn
	}
}
//*****************************************
// A/D 7 Get A/D data
//  obt@ɓĂf[^𕽋ςĎ擾
//  1.1V(A/D͓dj̎POQRɂȂ
//  obe[Ru̎ɂPDOu(A/D͓djɂȂ̂ŁA
//@obe|Ru̎͂XROɂȂ
//*****************************************
unsigned int	ad7_get_data(void)
{
	unsigned char	i;
	unsigned int	sum;

	sum = 0;
	for(i = 0; i < N_of_AD_data; i++){						// obt@Sđ
		sum += ad7_data[i];
	}

	sum /= N_of_AD_data;									// f[^Ŋĕϒlɂ

	return(sum);
}
