//*****************************************
// AVR ATmega644 Serial Monitor-G
// CPU Clock:8MHz,16MHz,18.432MHz or 20MHz(Compile Option)
// File Name:Comm1.c
//  Use UART0
// VAf[^iqrQRQbjj^[vO
//   iq[Yf[^@is`fgpȂAȂAwIV[^(16MHz)Aɂj
//   i`FbN͂rohdmj
//
//  2013/05/26 New  Taishi ATmega644
//*****************************************
#include				<avr/interrupt.h>
#include				<avr/io.h>
#include				<avr/pgmspace.h>

#include				"AVR_ATmega644_G_moni.h"
#include				"Serial.h"
#include				"LCD.h"
#include				"Utility.h"
#include				"Setting.h"
#include				"Display.h"
#include				"timer.h"

#include				"Comm1.h"


// peB@t`qsO
#define	V_PARITY0_NON	((0 << UPM01) | (0 << UPM00))									// peB
#define	V_PARITY0_EVN	((1 << UPM01) | (0 << UPM00))									// peB
#define	V_PARITY0_ODD	((1 << UPM01) | (1 << UPM00))									// peB

// f[^@t`qsO
#define	V_DATA0_8		((1 << UCSZ00) | (1 << UCSZ01))									// Wrbgf[^
#define	V_DATA0_7		((0 << UCSZ00) | (1 << UCSZ01))									// Vrbgf[^

// Xgbvrbg@t`qsO
#define	V_STOP0_1		(0 << USBS0)													// PrbgXgbv
#define	V_STOP0_2		(1 << USBS0)													// QrbgXgbv

// tbrqOa̒l
#ifdef		DEBUG_TX
#define	V_UCSR0B		((1 << RXEN0) | (1 << RXCIE0) | (1 << TXEN0))					// tbrqOa̒l: MAM荞݋AM
#else		//DEBUG_TX
#define	V_UCSR0B		((1 << RXEN0) | (1 << RXCIE0))									// tbrqOa̒l: MAM荞݋
#endif		//DEBUG_TX


unsigned int	v_parity0[CODE_PARITY_MAX+1] ={				// peBɑ΂ enum code_parity Ɠт̕KvL
						V_PARITY0_NON,						// peB
						V_PARITY0_EVN,						// peB
						V_PARITY0_ODD						// peB
				};

unsigned int	v_data0_length[CODE_DATA_MAX+1] ={			// f[^ɑ΂ enum code_data_length Ɠт̕KvL
						V_DATA0_8,							// Wrbgf[^
						V_DATA0_7							// Vrbgf[^
				};



volatile unsigned int	uart0_err_receiver;					// qwOG[ƎMf[^
volatile unsigned int	uart0_pass_time;					// oߎ

unsigned char	str_astarisk[] PROGMEM = {"******************"};
unsigned char	str_setting[] PROGMEM = {"***** Setting ****" "\r\n"};
unsigned char	str_data[] PROGMEM    = {"****** Data ******" "\r\n"};
unsigned char	str_no_data[] PROGMEM = {" No Data" "\r\n"};
unsigned char	str_n_of_data[] PROGMEM = {" N of Data:"};
unsigned char	str_hex[] PROGMEM = {"  HEX"};
unsigned char	str_ascii[] PROGMEM = {"  ASCII"};

//***************************
// UART0 Disable
// CPU Clock:16MHz
//***************************
void	uart0_disable(void)
{
	UCSR0B = 0;
	write_data_pos = 0;													// ݎMf[^|WV
	data_get_run = CODE_DATA_GET_END;									// Mf[^擾I
	rxd_rec = 0;														// qwO͂qwPM
}
#ifdef		DEBUG_TX
//***************************
// UART0 Pre Initial
// CPU Clock:16MHz
//***************************
void	uart0_pre_init(void)
{
#ifdef	UART_BAISOKU													// t`qs̃{[[gpNbN{ݒɂ
	UCSR0A |= (1 << U2X0);												// {
#endif

	UBRR0  = v_ubrr[set_bps];											// aor

	UCSR0C = (v_parity0[set_parity] | v_data0_length[set_data_length]);	// peBAf[^

	UCSR0B = (1 << TXEN0);												// tbrqOa̒l: M

	write_data_pos = 0;													// ݎMf[^|WV
	data_get_run = CODE_DATA_GET_END;									// Mf[^擾I
	rxd_rec = 0;														// qwO͂qwPM
}
#endif		//DEBUG_TX
//***************************
// UART0 Initial
// CPU Clock:16MHz
//***************************
void	uart0_init(void)
{
#ifdef	UART_BAISOKU													// t`qs̃{[[gpNbN{ݒɂ
	UCSR0A |= (1 << U2X0);												// {
#endif

	UBRR0  = v_ubrr[set_bps];											// aor

	UCSR0C = (v_parity0[set_parity] | v_data0_length[set_data_length]);	// peBAf[^

	UCSR0B = V_UCSR0B;

	write_data_pos = 0;													// ݎMf[^|WV
	data_get_run = CODE_DATA_GET_END;									// Mf[^擾I
	rxd_rec = 0;														// qwO͂qwPM
}

//***************************
// UART0 RXD Interrupt
//***************************
ISR	(USART0_RX_vect)
{
	uart0_err_receiver = (UCSR0A & ~0x01);										// G[Ԏ擾iŉʃrbgOFqwOj
	uart0_err_receiver <<= 8;
	uart0_err_receiver |= UDR0;													// Mf[^擾

	if(save_set_pass_time == CODE_PASS_TIME_ON){								// oߎԗL̎
		uart0_pass_time = get_pass_time_with_clear();							// oߎԎ擾iNA[tj
	}

	if(data_get_run == CODE_DATA_GET_WAIT){										// gKf[^҂
		if((uart0_err_receiver & 0x00ff)==trig_data){							// gKf[^ƈv
			if(set_end_less == CODE_TRIG_CYCL){									// X^[ggK{̎
				set_end_less = CODE_ONE_CYCL;									// ɂ
			}else{
				set_end_less = CODE_END_LESS;									// GhXɂ
			}
			data_get_run = CODE_DATA_GET_RUN;									// Mf[^擾ɂ
		}
	}

	if(data_get_run == CODE_DATA_GET_RUN){										// Mf[^擾
		if(save_set_pass_time == CODE_PASS_TIME_ON){							// oߎԗL̎
			rxd_err_data[write_data_pos] = uart0_pass_time;						// oߎԕۑ
			write_data_pos++;
			write_data_pos &= DATA_POS_MASK;
		}
		rxd_err_data[write_data_pos] = (uart0_err_receiver & ~0x0100);			// G[ԂƎMf[^擾iŉʃrbgOFqwOj
		write_data_pos++;
		write_data_pos &= DATA_POS_MASK;
		if(((set_end_less == CODE_ONE_CYCL)&&((N_of_RXD - 1) <= n_of_receive))											// Ńf[^obt@tɂȂA
			 || ((set_end_less == CODE_END_TRIG) && ((uart0_err_receiver & 0x00ff)==trig_data))							// ̓gKGhŃgKf[^̎
			 || ((set_end_less == CODE_ERR_END) && ((uart0_err_receiver & ((1 << (UPE0 + 8))|(1 << (FE0 + 8))))!=0)) ){	// ̓G[GhŃG[L
			data_get_run = CODE_DATA_GET_END;
			pass_time_stop();													// Passage Time stop
			disp_end_pos = 	((write_data_pos - 1) & DATA_POS_MASK);
			if(n_of_receive < n_of_disp_data){									// \܂ŎMĂȂ
				first_pos_num = 1;
			}else if( n_of_receive < N_of_RXD){									// Mf[^Mf[^obt@ȉ̎
				first_pos_num = n_of_receive - (n_of_disp_data - 2);
			}else{																// Mf[^obt@ȏ̎
				first_pos_num = N_of_RXD - (n_of_disp_data - 1);
			}
		}
		rxd_rec = 1;															// M
		tim_led = 2;															// kdc_
		if(n_of_receive < 999){
			n_of_receive++;														// 擾Mf[^{P
		}
	}
}

//***************************
// UART0 TXD One Data
//***************************
void	tx0_char(unsigned char uc)
{
	while((UCSR0A & (1 << UDRE0)) == 0){
		;
	}
	UDR0 = uc;								// Mf[^
}
//***************************
// UART0 TXD String
//***************************
void	tx0_str(unsigned char *uc)
{
	while(*uc != 0){
		tx0_char(*uc);						// UART TXD One Data
		uc++;
	}
}

//***************************
// UART0 TX Title
// 9600, 8, 2, NON
//***************************
void	tx_title(void)
{
	get_pgm_str(&str_astarisk[0]);			// vÖ̕("****")擾
	tx0_str( disp_moji);					// Transmit
	tx0_char(' ');
	get_title();
	tx0_str( disp_moji);					// Transmit
	tx0_char(' ');
	get_pgm_str(&str_astarisk[0]);			// vÖ̕("****")擾
	tx0_str( disp_moji);					// Transmit
	get_cr_lf();							// CR LF
	tx0_str( disp_moji);					// Transmit

}
//***************************
// UART0 TX Save Setting
// 9600, 8, 2, NON
//***************************
void	tx_save_setting(void)
{
	get_pgm_str(&str_setting[0]);			// vÖ̕("Setting")擾
	tx0_str( disp_moji);					// Transmit

	get_setting_bps();						// BPS
	tx0_str( disp_moji);					// Transmit
	tx0_char(',');

	get_setting_data_length();				// DATA LENGTH
	tx0_str( disp_moji);					// Transmit
	tx0_char(',');

	get_setting_parity();					// PARITY
	tx0_str( disp_moji);					// Transmit
	get_cr_lf();							// CR LF
	tx0_str( disp_moji);					// Transmit

	get_setting_endless_on_off();			// END LESS
	tx0_str( disp_moji);					// Transmit
	get_cr_lf();							// CR LF
	tx0_str( disp_moji);					// Transmit

	get_setting_pass_time_on_off();			// PASSAGE TIME
	tx0_str( disp_moji);					// Transmit
	get_cr_lf();							// CR LF
	tx0_str( disp_moji);					// Transmit
	tx0_str( disp_moji);					// Transmit
}
//***************************
// copy 21 char
//***************************
void	copy21(unsigned char *dst, unsigned char *suc, unsigned char num)
{
	unsigned char	i;

	for(i = 0; i < num; i++){
		*dst = *suc;
		dst++;
		suc++;
	}
}
//***************************
// UART0 TX Save Recieve Data
// 9600, 8, 2, NON
//***************************
void	tx_recieve_data(void)
{
	unsigned int	n;
	unsigned char	hajime=0;
	unsigned char	x=0;
	unsigned char	t=0;
	unsigned char	disp_moji1[21];
	unsigned char	disp_moji2[21];

	get_pgm_str(&str_data[0]);				// vÖ̕("Data")擾
	tx0_str( disp_moji);					// Transmit


	if(n_of_valid_rxd == 0){				// MĂȂ
		get_pgm_str(&str_no_data[0]);		// vÖ̕("No Data")擾
		tx0_str( disp_moji);				// Transmit
	}else{
		get_pgm_str(&str_n_of_data[0]);		// vÖ̕("N of Data")擾
		tx0_str( disp_moji);				// Transmit
		wtod_03u(&disp_moji[0],n_of_valid_rxd);
		tx0_str( disp_moji);				// Transmit
		if(disp_hex != 0){					// PUi\̎
			get_pgm_str(&str_hex[0]);		// vÖ̕("  HEX")擾
		}else{
			get_pgm_str(&str_ascii[0]);		// vÖ̕("  ASCII")擾
		}
		tx0_str( disp_moji);				// Transmit
		
		get_cr_lf();						// CR LF
		tx0_str( disp_moji);				// Transmit


		for(n=0; n < n_of_valid_rxd; n++){
			if(save_set_pass_time == CODE_PASS_TIME_ON){						// oߎԗL̎
				if((n % n_of_one_line_disp_data_pass)==0){
					hajime = 1;
					x = 0;
					t = 0;
					get_space20();
					copy21(&disp_moji1[0],disp_moji,21);						// PsڂɃXy[XRs[
					copy21(&disp_moji2[0],disp_moji,21);						// QsڂɃXy[XRs[
				}else{
					hajime = 0;
					x += 10;
				}

				if(hajime == 1){
					wtod_03u(&disp_moji[0], n+1);
					tx0_str( disp_moji);										// Transmit
				}

				// ʒuf[^
				make_pass_time_moji(rxd_err_data[n*2]);							// oߎԕ\
				if(((rxd_err_data[n*2+1] >> 8) & 1)==0){						// bnllP̎
					copy21(&disp_moji1[x+0],disp_moji,6);						// PsڂɃRs[
				}else{															// bnllQ̎
					copy21(&disp_moji2[x+0],disp_moji,6);						// QsڂɃRs[
				}

				// ʒuf[^
				make_disp_moji(n*2+1);											// \iRj
				if(((rxd_err_data[n*2+1] >> 8) & 1)==0){						// bnllP̎
					copy21(&disp_moji1[x+6],disp_moji,3);						// PsڂɃRs[
				}else{															// bnllQ̎
					copy21(&disp_moji2[x+6],disp_moji,3);						// QsڂɃRs[
				}

				if( (n % n_of_one_line_disp_data_pass) == (n_of_one_line_disp_data_pass - 1) ){
					t = 1;
				}

			}else{																// oߎԖ̎
				if((n % n_of_one_line_disp_data)==0){
					hajime = 1;
					x = 0;
					t = 0;
					get_space20();
					copy21(&disp_moji1[0],disp_moji,21);						// PsڂɃXy[XRs[
					copy21(&disp_moji2[0],disp_moji,21);						// QsڂɃXy[XRs[
				}else{
					hajime = 0;
					x += 4;
				}
				if(hajime == 1){
					wtod_03u(&disp_moji[0], n+1);
					tx0_str( disp_moji);										// Transmit
				}
				make_disp_moji(n);												// \iRj
				if(((rxd_err_data[n] >> 8) & 1)==0){							// bnllP̎
					copy21(&disp_moji1[x],disp_moji,3);							// PsڂɃRs[
				}else{															// bnllQ̎
					copy21(&disp_moji2[x],disp_moji,3);							// QsڂɃRs[
				}
				if((n % n_of_one_line_disp_data) == (n_of_one_line_disp_data-1) ){
					t = 1;
				}
			}

			if((n+1) == n_of_valid_rxd){
				t = 1;
			}

			if(t == 1){
				get_space20();						// Ps
				disp_moji[2] = 0;
				tx0_str( disp_moji);				// Transmit
				tx0_char('1');
				tx0_char('<');
				tx0_char('-');
				tx0_char('-');
				tx0_char(' ');
				tx0_str( disp_moji1);				// Transmit
				get_cr_lf();						// CR LF
				tx0_str( disp_moji);				// Transmit

				get_space20();						// Qs
				disp_moji[5] = 0;
				tx0_str( disp_moji);				// Transmit
				tx0_char('2');
				tx0_char('-');
				tx0_char('-');
				tx0_char('>');
				tx0_char(' ');
				tx0_str( disp_moji2);				// Transmit
				get_cr_lf();						// CR LF
				tx0_str( disp_moji);				// Transmit
				tx0_str( disp_moji);				// Transmit
			}
		}

	}
}
//***************************
// UART0 TX All Recieve Data
// 9600, 8, 2, NON
//***************************
void	tx_all_recieve_data(void)
{
	unsigned int	l_ubrr0;	// aqq ۑ
	unsigned char	l_ucsr0c;	// tbrqOb@ۑ
	unsigned char	l_ucsr0b;	// tbrqOa@ۑ

	// WX^̒lۑ
	l_ubrr0 = UBRR0;	// aor
	l_ucsr0c = UCSR0C;	// peBAf[^
	l_ucsr0b = UCSR0B;

	// Mp̃WX^ݒ
	UBRR0  = v_ubrr[CODE_9600];															// XUOOaor
	UCSR0C = (v_parity0[CODE_PARITY_NON] | v_data0_length[CODE_DATA_8] | V_STOP0_2 );	// peBȂAWrbgf[^AQXgbvrbg
	UCSR0B = (1 << TXEN0);																// tbrqOa̒l: M

	get_cr_lf();										// CR LF
	tx0_str( disp_moji);								// Transmit
	tx0_str( disp_moji);								// Transmit

	tx_title();											// TX Title
	tx_save_setting();									// TX Save Setting
	tx_recieve_data();									// TX Save Recieve Data

	// WX^̒l ߂
	UBRR0  =l_ubrr0 ;	// aor
	UCSR0C =l_ucsr0c;	// peBAf[^
	UCSR0B =l_ucsr0b;

}

#ifdef		DEBUG_TX
unsigned char	tx0_moji[4];													// fobOʐMp
//*****************************************
// fobOp\
// KX@e͕ύX
// tx_debug
//*****************************************
void	tx_debug(unsigned int num, unsigned char uc)
{
	wtod_03u(&tx0_moji[0], num);
	tx0_str(tx0_moji);
	tx0_str((unsigned char *)":");
	wtod_02x(&tx0_moji[0], uc);
	tx0_str(tx0_moji);
	tx0_str((unsigned char *)"H\r\n");
}
//*****************************************
// fobOpRPOi\
// KX@e͕ύX
// tx_debug
//*****************************************
void	tx_03_debug(unsigned int n)
{
	wtod_03u(&tx0_moji[0], n);
	tx0_str(tx0_moji);
	tx0_str((unsigned char *)"\r\n");
}
#endif		//DEBUG_TX
