//*****************************************
// AVR ATmega644 Serial Monitor-G
// CPU Clock:8MHz,16MHz,18.432MHz or 20MHz(Compile Option)
// File Name:Display.c
// VAf[^iqrQRQbjj^[vO
//   iq[Yf[^@is`fgpȂAȂAwIV[^(16MHz)Aɂj
//   i`FbN͂rohdmj
//
//  2013/05/26 New  Taishi ATmega644
//*****************************************
#include		<avr/io.h>
#include		<avr/pgmspace.h>

#include		"AVR_ATmega644_G_moni.h"
#include		"Serial.h"
#include		"Utility.h"
#include		"Setting.h"
#include		"LCD.h"
#include		"timer.h"

#include		"Display.h"

unsigned int	disp_start_pos;

unsigned char	pass_unit[8][2] PROGMEM = {
				{'u', 'S'},						// uS
				{'m', 'S'},						// 10uS
				{'m', 'S'},						// 100uS
				{'m', 'S'},						// 1mS
				{'S', ' '},						// 10mS
				{'S', ' '},						// 100mS
				{'S', ' '},						// 1S
				{'S', ' '},						// 1S
			};

//*****************************************
// oߎԕ\iUj
//  F@oߎԁiPOrbg̒l{Rrbg̒Pʁj
// \͂Qm@nɓ
// D0 -- D9 : Value
// D12 -- D15 : Unit
//          0 : uS
//          1 : 10uS
//          2 : 100uS
//          3 : 1mS
//          4 : 10mS
//          5 : 100mS
//          6 : 1S
//          7 : 1S
// static
//*****************************************
void	make_pass_time_moji(unsigned int pass)
{
	unsigned char	uc;

	wtod_03u(disp_moji, (pass & 0x3ff));
	uc = (pass >> 12) & 0x07;
	if((uc == 1) || (uc == 4)){								// 1,23mS or 1,23S
		disp_moji[3] = disp_moji[2];						// shift right char
		disp_moji[2] = disp_moji[1];
		disp_moji[1] = '.';									// Set '.'
	}else if((uc == 2) || (uc == 5)){						// 12.3mS or 12.3S
		disp_moji[3] = disp_moji[2];						// shift right one char
		disp_moji[2] = '.';									// Set '.'
	}else{
		disp_moji[3] = disp_moji[2];						// shift right one all char 
		disp_moji[2] = disp_moji[1];
		disp_moji[1] = disp_moji[0];
		disp_moji[0] = ' ';
	}
	disp_moji[4] = pgm_read_byte(&pass_unit[uc][0]);		// Set Unit
	disp_moji[5] = pgm_read_byte(&pass_unit[uc][1]);		// Set Unit
	disp_moji[6] = 0;										// Terminate

}
//*****************************************
// \iRj
//  F@f[^̈ʒu
// \͂Qm@nɓ
// static
//*****************************************
void	make_disp_moji(unsigned int pos)
{

	if((rxd_err_data[pos] & (1 << (FE0 + 8))) != 0){		// t[~OG[Ԃ̎
		disp_moji[0] = 'f';
	}else if((rxd_err_data[pos] & (1 << (UPE0 + 8))) != 0){	// peB[G[Ԃ̎
		disp_moji[0] = 'p';
	}else if((rxd_err_data[pos] & (1 << (DOR0 + 8))) != 0){	// I[o[G[Ԃ̎
		disp_moji[0] = 'o';
	}else{
		disp_moji[0] = ' ';
	}

	if(disp_hex != 0){										// PUi\̎
		wtod_02x(&disp_moji[1], rxd_err_data[pos] & 0xff);
	}else{
		if((rxd_err_data[pos] & 0xff) < 0x20){				// Mf[^OQO̎
			disp_moji[1] = '^';
			disp_moji[2] = '@'+(rxd_err_data[pos] & 0xff);
		}else{
			disp_moji[1] = disp_moji[0];
			disp_moji[0] = ' ';
			disp_moji[2] = (rxd_err_data[pos] & 0xff);
		}
		disp_moji[3] = 0;									// ^[~lCg
	}
}
//*****************************************
// ő̎Mf[^\
// \Mf[^ʒu̍ŏ̕read_data_pos ɗL
// static
//*****************************************
void	disp_recieve_n_data(void)
{
	unsigned char	i;

	disp_clear_lcd_G();															// Clear Display

	for(i=0; i < n_of_disp_data; i++){
		make_disp_moji(read_data_pos);											// \iRj
		disp_lcd_G((i % n_of_one_line_disp_data)*4+1, ((rxd_err_data[read_data_pos] >> 8) & 1)+((i / n_of_one_line_disp_data)*2), disp_moji);	// display LCD
		read_data_pos++;														// ǂݏoMf[^|WV
		read_data_pos &= DATA_POS_MASK;
		if(read_data_pos == disp_write_data_pos){
			break;
		}
	}

	disp_direction_signe_lcd_G();												// Direction Signe
	disp_lcd_icon_G();															// display LCD Icon

}
//*****************************************
// ő̎Mf[^Aoߎԕ\
// \Mf[^ʒu̍ŏ̕read_data_pos ɗL
// static
//*****************************************
void	disp_recieve_n_data_pass(void)
{
	unsigned char	i;
	unsigned char	l;

	disp_clear_lcd_G();															// Clear Display

	l = read_data_pos;

	for(i=0; i < (n_of_disp_data_pass * 2); i++){
		if((l & 0x01)==0){														// Ԗڂ̎
			make_pass_time_moji(rxd_err_data[l]);								// oߎԕ\
			disp_lcd_G(((i/2) % n_of_one_line_disp_data_pass)*10+1, ((rxd_err_data[l+1] >> 8) & 1)+(((i/2) / n_of_one_line_disp_data_pass)*2), disp_moji);	// display LCD
		}else{																	// Ԗڂ̎
			make_disp_moji(l);													// \iRj
			disp_lcd_G(((i/2) % n_of_one_line_disp_data_pass)*10+7, ((rxd_err_data[l] >> 8) & 1)+(((i/2) / n_of_one_line_disp_data_pass)*2), disp_moji);	// display LCD
		}
		l++;																	// ǂݏoMf[^|WV
		l &= DATA_POS_MASK;
		if(l == disp_write_data_pos){
			break;
		}
	}

	disp_direction_signe_lcd_G();												// Direction Signe
	disp_lcd_icon_G();															// display LCD Icon

}
//*****************************************
// Mf[^\
//*****************************************
void	disp_recieve_data(void)
{
	unsigned char	n;

	n = n_of_receive;
	disp_write_data_pos = write_data_pos;

	if(save_set_pass_time == CODE_PASS_TIME_ON){								// oߎԗL̎
		if(n < n_of_disp_data_pass - 1){										// \܂ŎMĂȂ
			read_data_pos = disp_write_data_pos - n * 2;						// ǂݏoMf[^|WV
		}else{
			read_data_pos = disp_write_data_pos - (n_of_disp_data_pass - 1)*2;	// ǂݏoMf[^|WV
		}
		read_data_pos &= DATA_POS_MASK;
		disp_recieve_n_data_pass();												// Mf[^Aoߎԕ\
	}else{																		// oߎԖ̎
		if(n < n_of_disp_data){													// \܂ŎMĂȂ
			;
		}else{
			n = n_of_disp_data;
		}
		read_data_pos = disp_write_data_pos - n;								// ǂݏoMf[^|WV
		read_data_pos &= DATA_POS_MASK;
		disp_recieve_n_data();													// Mf[^\
	}
}

//*****************************************
// start_pos ɕ\s
//*****************************************
void	disp_one_block(unsigned int start_pos)
{
	unsigned char	i;
	unsigned int	l;

	if(n_of_valid_rxd == 0){													// MĂȂ
		disp_moji[0] = '0';
		disp_moji[1] = '0';
		disp_moji[2] = '0';
		disp_moji[3] = 0;
		disp_lcd_G(0, 1, disp_moji);											// display LCD Down Side
	}else{																		// MĂ鎞

		disp_clear_lcd_G();														// Clear Display

		if(save_set_pass_time == CODE_PASS_TIME_ON){							// oߎԗL̎
			for(i=0,l = start_pos; (i < (n_of_disp_data_pass * 2))&&(l < (n_of_valid_rxd * 2)); i++,l++){
				if((l & 0x01)==0){												// Ԗڂ̎
					make_pass_time_moji(rxd_err_data[l]);					// oߎԕ\
					disp_lcd_G(((i/2) % n_of_one_line_disp_data_pass)*10+1, ((rxd_err_data[l+1] >> 8) & 1)+(((i/2) / n_of_one_line_disp_data_pass)*2), disp_moji);	// display LCD
				}else{															// Ԗڂ̎
					make_disp_moji(l);											// \iRj
					disp_lcd_G(((i/2) % n_of_one_line_disp_data_pass)*10+7, ((rxd_err_data[l] >> 8) & 1)+(((i/2) / n_of_one_line_disp_data_pass)*2), disp_moji);	// display LCD
				}
			}
		}else{																	// oߎԖ̎
			for(i=0,l = start_pos; (i < n_of_disp_data)&&(l < n_of_valid_rxd); i++,l++){
				make_disp_moji(l);												// \iRj
				disp_lcd_G((i % n_of_one_line_disp_data)*4+1, ((rxd_err_data[l] >> 8) & 1)+((i / n_of_one_line_disp_data)*2), disp_moji);	// display LCD
			}
		}

		disp_direction_signe_lcd_G();											// Direction Signe
		disp_lcd_icon_G();															// display LCD Icon

		if(save_set_pass_time == CODE_PASS_TIME_ON){							// oߎԗL̎
			wtod_03u(&disp_moji[0], ((start_pos/2) + 1));
			if((rxd_err_data[start_pos+1] & 0x0100) == 0){						// ō̎Mf[^qwcO̎
				disp_lcd_G(0, 1, disp_moji);									// display LCD Down Side
			}else{																// ō̎Mf[^qwcP̎
				disp_lcd_G(0, 0, disp_moji);									// display LCD Up Side
			}
		}else{																	// oߎԖ̎
			wtod_03u(&disp_moji[0], (start_pos + 1));
			if((rxd_err_data[start_pos] & 0x0100) == 0){						// ō̎Mf[^qwcO̎
				disp_lcd_G(0, 1, disp_moji);									// display LCD Down Side
			}else{																// ō̎Mf[^qwcP̎
				disp_lcd_G(0, 0, disp_moji);									// display LCD Up Side
			}
		}
	}
}

//*****************************************
// gKf[^p\
//*****************************************
void	disp_trig_data(void)
{
	if((set_end_less == CODE_STR_TRIG)||(set_end_less == CODE_END_TRIG)||(set_end_less == CODE_TRIG_CYCL)){
		wtod_02x(&disp_moji[1],trig_data);
		disp_moji[0] = '-';
	}else{
		disp_moji[0] = ' ';
		disp_moji[1] = ' ';
		disp_moji[2] = ' ';
		disp_moji[3] = 0;
	}
	disp_lcd_G(POS_TRIG_DATA,1,disp_moji);								// display LCD Down Side
}

//*****************************************
// ݌oߎԕ\
//  Fpos_x ʒu(0 --> 19)
//  @@@pos_y sʒu(0 --> 7)
//*****************************************
void	disp_pass_time(unsigned char pos_x, unsigned char pos_y)
{
	unsigned int	pas;

	pas = get_pass_time();						// Get Passage Time
	make_pass_time_moji(pas);					// oߎԕ\
	disp_lcd_G(pos_x,pos_y,disp_moji);			// display LCD
}

#ifdef		DEBUG_DISP
//*****************************************
// fobOp\
// KX@e͕ύX
// disp_debug
//*****************************************
void	disp_debug(void)
{

}
//*****************************************
// fobOp\
// KX@e͕ύX
// disp_debug2
//*****************************************
void	disp_debug2(void)
{
	wtod_03u(&disp_moji[0], v_ubrr[0]);
	disp_lcd_G( 1, 3, disp_moji);											// display LCD

	wtod_03u(&disp_moji[0], v_ubrr[1]);
	disp_lcd_G(11, 3, disp_moji);											// display LCD

	wtod_03u(&disp_moji[0], v_ubrr[2]);
	disp_lcd_G( 1, 4, disp_moji);											// display LCD

	wtod_03u(&disp_moji[0], v_ubrr[3]);
	disp_lcd_G(11, 4, disp_moji);											// display LCD

	wtod_03u(&disp_moji[0], v_ubrr[4]);
	disp_lcd_G( 1, 5, disp_moji);											// display LCD

	wtod_03u(&disp_moji[0], v_ubrr[5]);
	disp_lcd_G(11, 5, disp_moji);											// display LCD

	wtod_03u(&disp_moji[0], v_ubrr[6]);
	disp_lcd_G( 1, 6, disp_moji);											// display LCD

}
#endif		//DEBUG_DISP
