//*****************************************
// AVR ATmega644 Serial Monitor-G
// CPU Clock:8MHz,16MHz,18.432MHz or 20MHz(Compile Option)
// File Name:EEPROM.c
// VAf[^iqrQRQbjj^[vO
//   iq[Yf[^@is`fgpȂAȂAwIV[^(16MHz)Aɂj
//   i`FbN͂rohdmj
//
//  2013/05/26 New  Taishi ATmega644
//*****************************************
#include		<avr/interrupt.h>
#include		<avr/io.h>
#include		<avr/eeprom.h>

#include		"AVR_ATmega644_G_moni.h"
#include		"Serial.h"
#include		"LCD.h"
#include		"Display.h"
#include		"Setting.h"

#include		"EEPROM.h"

// ddoqnl
unsigned int	eep_rxd_valid[2] EEMEM;
unsigned int	eep_n_of_valid_rxd[2] EEMEM;
unsigned int	eep_dumy[2] EEMEM;
unsigned int	eep_rxd_err_data[N_of_RXD] EEMEM;

unsigned char	eep_set_bps[1] EEMEM ={
					CODE_9600
					};

unsigned char	eep_set_parity[1] EEMEM ={
					CODE_PARITY_NON
					};

unsigned char	eep_set_data_length[1] EEMEM ={
					CODE_DATA_8
					};

unsigned char	eep_set_end_less[1] EEMEM ={
					CODE_END_LESS
					};

unsigned char	eep_trig_data[1] EEMEM ={
					0x00
					};

unsigned char	eep_set_pass_time[1] EEMEM ={
					CODE_PASS_TIME_OFF
					};

unsigned char	eep_save_set_bps[1] EEMEM ={
					CODE_9600
					};

unsigned char	eep_save_set_parity[1] EEMEM ={
					CODE_PARITY_NON
					};

unsigned char	eep_save_set_data_length[1] EEMEM ={
					CODE_DATA_8
					};

unsigned char	eep_save_set_end_less[1] EEMEM ={
					CODE_END_LESS
					};

unsigned char	eep_save_trig_data[1] EEMEM ={
					0x00
					};

unsigned char	eep_save_set_pass_time[1] EEMEM ={
					CODE_PASS_TIME_OFF
					};

unsigned char	eep_set_back_light[1] EEMEM ={
					0
					};

//*****************************************
// ݒf[^ddoqnlɕۑ
//*****************************************
void	save_setting_to_eeprom(void)
{

	cli();

	if(set_bps != eeprom_read_byte(eep_set_bps)){					// aorR[h
		eeprom_busy_wait();
		eeprom_write_byte(eep_set_bps, set_bps);
	}
	if(set_parity != eeprom_read_byte(eep_set_parity)){				// peBR[h
		eeprom_busy_wait();
		eeprom_write_byte(eep_set_parity, set_parity);
	}
	if(set_data_length != eeprom_read_byte(eep_set_data_length)){	// f[^R[h
		eeprom_busy_wait();
		eeprom_write_byte(eep_set_data_length, set_data_length);
	}
	if(set_end_less != eeprom_read_byte(eep_set_end_less)){			// GhXR[h
		eeprom_busy_wait();
		eeprom_write_byte(eep_set_end_less, set_end_less);
	}
	if(trig_data != eeprom_read_byte(eep_trig_data)){				// gKf[^
		eeprom_busy_wait();
		eeprom_write_byte(eep_trig_data, trig_data);
	}
	if(set_pass_time != eeprom_read_byte(eep_set_pass_time)){		// oߎԗL
		eeprom_busy_wait();
		eeprom_write_byte(eep_set_pass_time, set_pass_time);
	}
	if(set_back_light != eeprom_read_byte(eep_set_back_light)){		// obNCg@nm^nee
		eeprom_busy_wait();
		eeprom_write_byte(eep_set_back_light, set_back_light);
	}
	eeprom_busy_wait();

	sei();
}
//*****************************************
// ݒf[^ddoqnl擾
//*****************************************
void	load_setting_from_eeprom(void)
{
	unsigned char	uc;

	eeprom_busy_wait();
	uc = eeprom_read_byte(eep_set_bps);					// aorR[h
	if(uc < CODE_BPS_MAX){								// BPS ͈͓
		set_bps = uc;
	}
	eeprom_busy_wait();
	uc = eeprom_read_byte(eep_set_parity);				// peBR[h
	if(uc < CODE_PARITY_MAX){							// peB ͈͓
		set_parity = uc;
	}

	eeprom_busy_wait();
	uc = eeprom_read_byte(eep_set_data_length);			// f[^R[h
	if(uc < CODE_DATA_MAX){								// f[^ ͈͓
		set_data_length = uc;
	}

	eeprom_busy_wait();
	uc = eeprom_read_byte(eep_set_end_less);			// GhXR[h
	if(uc < CODE_END_MAX){								// GhX ͈͓
		set_end_less = uc;
	}

	eeprom_busy_wait();
	trig_data = eeprom_read_byte(eep_trig_data);		// gKf[^

	eeprom_busy_wait();
	uc = eeprom_read_byte(eep_set_pass_time);			// oߎԗL
	if(uc < CODE_PASS_MAX){								// oߎԗL ͈͓
		set_pass_time = uc;
	}

	eeprom_busy_wait();
	uc = eeprom_read_byte(eep_set_back_light);			// obNCg@nm^nee
	if(uc < 2){											// obNCg ͈͓
		set_back_light = uc;
	}

}
//*****************************************
// Mf[^ddoqnlɕۑ
//*****************************************
void	save_rxd_to_eeprom(void)
{
	unsigned short	i;

	cli();
	eeprom_busy_wait();
	eeprom_write_word(eep_rxd_valid,0x3412);							// ۑf[^L蕄
	eeprom_busy_wait();
	eeprom_write_word(eep_n_of_valid_rxd, n_of_valid_rxd);				// LMf[^
	eeprom_busy_wait();
	for(i=0;i<N_of_RXD;i++){
		eeprom_busy_wait();
		eeprom_write_word(eep_rxd_err_data + i, rxd_err_data[i]);		// ۑMf[^
	}
	eeprom_busy_wait();
	eeprom_write_byte(eep_save_set_bps, save_set_bps);					// ۑMf[^BPS
	eeprom_busy_wait();
	eeprom_write_byte(eep_save_set_parity, save_set_parity);			// ۑMf[^Parity
	eeprom_busy_wait();
	eeprom_write_byte(eep_save_set_data_length, save_set_data_length);	// ۑMf[^Data Length
	eeprom_busy_wait();
	eeprom_write_byte(eep_save_set_end_less, save_set_end_less);		// ۑMf[^END-LESS
	eeprom_busy_wait();
	eeprom_write_byte(eep_save_trig_data, save_trig_data);				// ۑMf[^Trig. Data
	eeprom_busy_wait();
	eeprom_write_byte(eep_save_set_pass_time, set_pass_time);			// ۑMf[^̌oߎԂ̗L
	eeprom_busy_wait();

	sei();
}
//*****************************************
// Mf[^ddoqnl擾
//*****************************************
void	load_rxd_from_eeprom(void)
{
	unsigned short	i;

	eeprom_busy_wait();
	if(eeprom_read_word(eep_rxd_valid) == 0x3412){							// ۑf[^L̎
		eeprom_busy_wait();
		n_of_valid_rxd = eeprom_read_word(eep_n_of_valid_rxd);				// Mf[^
		for(i=0;i<N_of_RXD;i++){
			eeprom_busy_wait();
			rxd_err_data[i] = eeprom_read_word(eep_rxd_err_data + i);		// ۑMf[^
		}
		eeprom_busy_wait();
		save_set_bps = eeprom_read_byte(eep_save_set_bps);					// ۑMf[^BPS
		eeprom_busy_wait();
		save_set_parity = eeprom_read_byte(eep_save_set_parity);			// ۑMf[^Parity
		eeprom_busy_wait();
		save_set_data_length = eeprom_read_byte(eep_save_set_data_length);	// ۑMf[^Data Length
		eeprom_busy_wait();
		save_set_end_less = eeprom_read_byte(eep_save_set_end_less);		// ۑMf[^END-LESS
		eeprom_busy_wait();
		save_trig_data = eeprom_read_byte(eep_save_trig_data);				// ۑMf[^Trig. Data
		eeprom_busy_wait();
		eeprom_busy_wait();
		save_set_pass_time = eeprom_read_byte(eep_save_set_pass_time);		// ۑMf[^̌oߎԂ̗L

		disp_start_pos = 0;
		if(n_of_valid_rxd == 0){
			disp_clear_lcd_G();												// Clear Display
			disp_lcd_G(0, 0, (unsigned char *)"Please");					// display LCD Up Side
			disp_lcd_G(1, 1, (unsigned char *)"Push Start SW");				// display LCD Down Side
		}else{
			disp_one_block(disp_start_pos);									// disp_start_pos ɕ\s
		}
	}else{
		disp_clear_lcd_G();													// Clear Display
		disp_lcd_G(0, 0, (unsigned char *)"Please");						// display LCD Up Side
		disp_lcd_G(1, 1, (unsigned char *)"Push Start SW");					// display LCD Down Side
	}
}

