//*****************************************
// AVR ATmega644 Serial Monitor-G
// CPU Clock:8MHz,16MHz,18.432MHz or 20MHz(Compile Option)
// File Name:LCD.c
// VAf[^iqrQRQbjj^[vO
//   iq[Yf[^@is`fgpȂAȂAwIV[^(16MHz)Aɂj
//   i`FbN͂rohdmj
//
//  2013/05/26 New  Taishi ATmega644
//*****************************************
#include		<avr/io.h>
#include		<avr/pgmspace.h>

#include		"AVR_ATmega644_G_moni.h"
#include		"Serial.h"
#include		"Utility.h"
#include		"Setting.h"
#include		"Comm1.h"
#include		"timer.h"

#include		"Pfont5x7.h"
#include		"LCD.h"


unsigned int	disp_write_data_pos;													// \pݎMf[^|WV
unsigned int	read_data_pos;															// ǂݏoMf[^JE^[
unsigned int	disp_end_pos;
unsigned char	disp_hex;																// 1:PUi\
unsigned char	disp_moji[21];															// kbc\
unsigned char	n_of_disp_data = 20;													// kbc\鐔̍ő吔
unsigned char	n_of_one_line_disp_data = 5;											// Psɕ\f[^
unsigned char	n_of_line = 8;															// kbc\s
unsigned char	n_of_disp_data_pass = 8;												// oߎԗL̂kbc\鐔̍ő吔
unsigned char	n_of_one_line_disp_data_pass = 2;										// oߎԗL̂Psɕ\f[^
unsigned char	set_back_light;															// obNCgnm^nee
unsigned char	icon_data;																// ACRf[^ (rbgΉD0:dr, D1:, D2:, D3:Op)

// ************************************* Graphic LCD Accese *********************
unsigned char	c_data[5];

unsigned char	hidarimuki[4]={
	0b00000100,								// '<'
	0b00001010,
	0b00010001,
	0b00000000
};

unsigned char	migimuki[4]={
	0b01000101,								// '>'
	0b00101001,
	0b00010001,
	0b00000001
};


//******************************
// Get Character Bit Data
// 5x7 Font
//  Get Data Save to c_data[5];
//******************************
static void	get_asc_data(unsigned char uc)
{
	unsigned short	us;

	us = uc;

	c_data[0] = pgm_read_byte(&(font5x7[us * 5 + 0]));
	c_data[1] = pgm_read_byte(&(font5x7[us * 5 + 1]));
	c_data[2] = pgm_read_byte(&(font5x7[us * 5 + 2]));
	c_data[3] = pgm_read_byte(&(font5x7[us * 5 + 3]));
	c_data[4] = pgm_read_byte(&(font5x7[us * 5 + 4]));
}

//******************************
// LCD Wait Busy
//
// PC3:E
// PC4:D/I*
// PA7:DB7
// PA6:DB6
// PA5:DB5
// PA4:DB4
// PA3:DB3
// PA2:DB2
// PA1:DB1
// PA0:DB0
// PC1:CS2
// PC2:CS1
// PC0:R/W*
// \߁@brP͂brQ͐ݒ肵Ă
// d̏グ̑OɃfB[KvLiȂƓ삪j
//  kbco͂ɃG[L͂kdcG[_łŉiv[v
// *****************************
static void	lcd_G_wait_busy(void)
{
	unsigned char	l_uc;
	unsigned char	i;

	e_low();																// E Sig:Low

	select_port_input();													// DB0 -- DB7 Input
	output_port = 0xff;														// DB0 -- DB7 Pullup
	select_instruction();													// D/I* Sig:Low
	select_read();															// R/W* Sig:High

	delay_2us(1);															// fB[
	for(i=0;i<10;i++){														// ̃[v͂قƂǂPłɂȂBPOɂȂُ͈̂펖
		e_high();															// E Sig:High
		delay_2us(1);														// fB[
		l_uc = PINA;
		l_uc = input_port;
		e_low();															// E Sig:Low

		if((l_uc & (1 << PINA7)) == 0){										// Check Busy 0:Ready
			break;
		}
		delay_2us(1);														// fB[
	}
	output_port = 0x00;														// DB0 -- DB7 Pullup

	if( 10<= i){
		lcd_error();
	}
}
//******************************
// LCD Data Output
//  cs : 0 or 1 (0:CS1, 1:CS2)
//  uc : Output Data(D0 -- D7)
//  rs : RS bit Data(0=Command, 1=Data)

// PC3:E
// PC4:D/I*
// PA7:DB7
// PA6:DB6
// PA5:DB5
// PA4:DB4
// PA3:DB3
// PA2:DB2
// PA1:DB1
// PA0:DB0
// PC1:CS2
// PC2:CS1
// PC0:R/W*
// d̏グ̑OɃfB[KvLiȂƓ삪j
//  kbco͂ɃG[L͂kdcG[_łŉiv[v
// *****************************
static void	lcd_G_one_out(unsigned char cs, unsigned char uc, int rs)
{
//	cs1_on();															// CS1 Sig:High
//	lcd_G_wait_busy();													// LCD Wait Busy
//	cs2_on();															// CS2 Sig:High
//	lcd_G_wait_busy();													// LCD Wait Busy

	if(cs == 0){															// CS1
		cs2_off();															// CS2 Sig:Low
		cs1_on();															// CS1 Sig:High
	}else{																	// CS2
		cs1_off();															// CS1 Sig:Low
		cs2_on();															// CS2 Sig:High
	}

	lcd_G_wait_busy();														// LCD Wait Busy

	select_port_output();													// DA0 -- DA7 Output

	select_write();															// R/W* Sig:Low
	if((rs & 0x01) == 0){													// RS:0(Command)
		select_instruction();												// D/I* Sig:Low
	}else{																	// RS:1(Data)
		select_data();														// D/I* Sig:High
	}
	output_port = uc;

	delay_2us(1);															// fB[
	e_high();																// E Sig:High
	delay_2us(1);															// fB[
	cs1_off();																// CS1 Sig:Low
}
//******************************
// LCD Command Output
//  cs : 0 or 1 (0:CS1, 1:CS2)
//  uc : Command Data(D0 -- D7)
//  kbco͂ɃG[L͂kdcG[_łŉiv[v
// *****************************
static void	lcd_G_cmd_out(unsigned char cs, unsigned char uc)
{
	lcd_G_one_out(cs, uc, 0);
}
//******************************
// LCD Data Output
//  cs : 0 or 1 (0:CS1, 1:CS2)
//  uc : Data(D0 -- D7)
//  kbco͂ɃG[L͂kdcG[_łŉiv[v
// *****************************
static void	lcd_G_data_out(unsigned char cs, unsigned char uc)
{
	lcd_G_one_out(cs, uc, 1);
}
//******************************
// Init. LCD
//  kbco͂ɃG[L͂kdcG[_łŉiv[v
// *****************************
void	init_lcd_G(void)
{
	DDRC |= ((1 << DDC0) | (1 << DDC1) | (1 << DDC2) | (1 << DDC3) | (1 << DDC4) | (1 << DDC5));		// RST*, D/I*, E, CS1, CS2, R/W* Output
	select_port_output();																				// DA0 -- DA7 Output
	e_low();																							// E Sig:Low
	select_instruction();																				// D/I* Sig:Low
	cs2_off();																							// CS2 Sig:Low
	cs1_off();																							// CS1 Sig:Low
	select_write();																						// R/W* Sig:Low

	rst_on();																							// Reset* Sig:Low
	delay_ms(100);
	rst_off();																							// Reset* Sig:High

	delay_ms(100);

	lcd_G_cmd_out(0, 0xc0);																				// CS1, Display Start Line:0
	lcd_G_cmd_out(0, 0x3f);																				// CS1, Display ON
	lcd_G_cmd_out(1, 0xc0);																				// CS2, Display Start Line:0
	lcd_G_cmd_out(1, 0x3f);																				// CS2, Display ON
}
//******************************
// Clear Display
//  kbco͂ɃG[L͂kdcG[_łŉiv[v
// *****************************
void	disp_clear_lcd_G(void)
{
	unsigned char	x;
	unsigned char	y;

	for(y=0;y < 8;y++){
		lcd_G_cmd_out(0, (0xb8 | y));			// CS1 Page Set
		lcd_G_cmd_out(0, 0x40);					// CS1 Column Address Set
		for(x=0;x < 64; x++){
			lcd_G_data_out(0, 0x00);
		}

		lcd_G_cmd_out(1, (0xb8 | y));			// CS2 Page Set
		lcd_G_cmd_out(1, 0x40);					// CS2 Column Address Set
		for(x=0;x < 64; x++){
			lcd_G_data_out(1, 0x00);
		}
	}
}
//******************************
// display LCD 4 Line
//  grph_x : Position X(0 -- 127)
//  pos_y : Position Y(0 -- 7)
//  uc : Line Data
//  kbco͂ɃG[L͂kdcG[_łŉiv[v
// *****************************
void	disp_4_line_lcd_G(unsigned char grph_x, unsigned char pos_y, unsigned char *uc)
{
	unsigned char	x;
	unsigned char	cs;

	if(grph_x < 64){						// CS1
		x = grph_x;
		cs = 0;
	}else{									// CS2
		x = grph_x - 64;
		cs = 1;
	}
	lcd_G_cmd_out(cs, (0xb8 | pos_y));		// CS1 or 2  Page Set
	lcd_G_cmd_out(cs, (0x40 | x));			// CS1 or 2  Column Address Set
	lcd_G_data_out(cs, *(uc+0));
	lcd_G_data_out(cs, *(uc+1));
	lcd_G_data_out(cs, *(uc+2));
	lcd_G_data_out(cs, *(uc+3));
}
//******************************
// display LCD One charcter
//  pos_x : Position X(0 -- 19)
//  pos_y : Position Y(0 -- 7)
//  uc : Charcter
//  kbco͂ɃG[L͂kdcG[_łŉiv[v
// *****************************
void	disp_one_char_lcd_G(unsigned char pos_x, unsigned char pos_y, unsigned char uc)
{
	unsigned char	x;
	unsigned char	cs;

	get_asc_data(uc);						// Get Character Bit Data
	if(pos_x < 10){							// CS1
		x = (pos_x * 6 +4);
		cs = 0;
	}else{									// CS2
		x = ((pos_x - 10) * 6);
		cs = 1;
	}
	lcd_G_cmd_out(cs, (0xb8 | pos_y));		// CS1 or 2  Page Set
	lcd_G_cmd_out(cs, (0x40 | x));			// CS1 or 2  Column Address Set
	lcd_G_data_out(cs, c_data[0]);
	lcd_G_data_out(cs, c_data[1]);
	lcd_G_data_out(cs, c_data[2]);
	lcd_G_data_out(cs, c_data[3]);
	lcd_G_data_out(cs, c_data[4]);
	lcd_G_data_out(cs, 0x00);
}
//******************************
// display LCD(20char x 8Line)
//  pos_x : Position X(0 -- 19)
//  pos_y : Position Y(0 -- 7)
//  ucp : String(termnate 0x00)
//  kbco͂ɃG[L͂kdcG[_łŉiv[v
// *****************************
void	disp_lcd_G(unsigned char pos_x, unsigned char pos_y, unsigned char *ucp)
{
	unsigned char	pos;

	pos = pos_x;
	while(*ucp != 0x00){				// String Data Out
		if(19 < pos){
			break;
		}
		disp_one_char_lcd_G(pos, pos_y, *ucp);
		ucp++;
		pos++;
	}
}
//******************************
// display LCD 
//  kbco͂ɃG[L͂kdcG[_łŉiv[v
// *****************************
void	disp_direction_signe_lcd_G(void)
{
//	disp_4_line_lcd_G(124, 1, hidarimuki);
//	disp_4_line_lcd_G(124, 3, hidarimuki);
//	disp_4_line_lcd_G(124, 5, hidarimuki);
//	disp_4_line_lcd_G(124, 7, hidarimuki);

	disp_4_line_lcd_G(0, 1, hidarimuki);
	disp_4_line_lcd_G(0, 3, hidarimuki);
	disp_4_line_lcd_G(0, 5, hidarimuki);
	disp_4_line_lcd_G(0, 7, hidarimuki);

	disp_4_line_lcd_G(0, 0, migimuki);
	disp_4_line_lcd_G(0, 2, migimuki);
	disp_4_line_lcd_G(0, 4, migimuki);
	disp_4_line_lcd_G(0, 6, migimuki);
}

//******************************
// display LCD Icon
//  \߁@icon_data \ACR̓Zbg邱	
//  kbco͂ɃG[L͂kdcG[_łŉiv[v
// *****************************
void	disp_lcd_icon_G(void)
{
	unsigned char	x;
	unsigned char	y;
	unsigned char	cs;

	x = 60;
	y = 7;
	cs = 1;

	lcd_G_cmd_out(cs, (0xb8 | y));		// CS2  Page Set
	lcd_G_cmd_out(cs, (0x40 | x));		// CS2  Column Address Set

	if((icon_data & 0x08)==0){			// dr}[N
		lcd_G_data_out(cs, 0x00);
	}else{
		lcd_G_data_out(cs, 0x80);
	}

	if((icon_data & 0x04)==0){			// ƃ}[N
		lcd_G_data_out(cs, 0x00);
	}else{
		lcd_G_data_out(cs, 0x80);
	}

	if((icon_data & 0x02)==0){			// ۃ}[N
		lcd_G_data_out(cs, 0x00);
	}else{
		lcd_G_data_out(cs, 0x80);
	}

	if((icon_data & 0x01)==0){			// Op}[N
		lcd_G_data_out(cs, 0x00);
	}else{
		lcd_G_data_out(cs, 0x80);
	}
}

//******************************
// Back Light ON/OFF
//   lon: 0=OFF, 1=ON
// *****************************
void	back_light(unsigned char lon)
{
	if(lon == 0){
		PORTD &=  ~(1 << PD7);									// Back Light FET OFF
	}else{
		PORTD |=  (1 << PD7);									// Back Light FET ON
	}
}

#ifdef		CHECK_FONT											// tHg`FbN\
//******************************
// display Font LCD(20char x 8Line)
//  Code 0x00 --> 0x7f
// *****************************
void	disp_lcd_G_font_check1(void)
{
	unsigned char	x;
	unsigned char	y;
	unsigned char	uc;

	uc = 0;
	for(y=0;y<8;y++){
		for(x=0;x<16;x++){
			disp_one_char_lcd_G(x, y, uc);
			uc++;
		}
	}
}

//******************************
// display Font LCD(20char x 8Line)
//  Code 0x80 --> 0xff
// *****************************
void	disp_lcd_G_font_check2(void)
{
	unsigned char	x;
	unsigned char	y;
	unsigned char	uc;

	uc = 0x80;
	for(y=0;y<8;y++){
		for(x=0;x<16;x++){
			disp_one_char_lcd_G(x, y, uc);
			uc++;
		}
	}
}
#endif		//CHECK_FONT
