//*****************************************
// AVR ATmega644 Serial Monitor-G
// CPU Clock:8MHz,16MHz,18.432MHz or 20MHz(Compile Option)
// File Name:LCD.h
//  wb_[t@C
//
// for TG12864E-01XWBV & SG12864A (Controler:S6B0107)
//  2013/05/26 New  Taishi ATmega644
//*****************************************
// ******** MACRO ********

#define	rst_on()				(PORTA &= ~(1 << PA5))					// Reset* Sig:Low
#define	rst_off()				(PORTA |=  (1 << PA5))					// Reset* Sig:High
#define	select_instruction()	(PORTA &= ~(1 << PA4))					// D/I* Sig:Low
#define	select_data()			(PORTA |=  (1 << PA4))					// D/I* Sig:High
#define	e_low()					(PORTA &= ~(1 << PA3))					// E Sig:Low
#define	e_high()				(PORTA |=  (1 << PA3))					// E Sig:High
#define	cs1_on()				(PORTA |=  (1 << PA2))					// CS1 Sig:High
#define	cs1_off()				(PORTA &= ~(1 << PA2))					// CS1 Sig:Low
#define	cs2_on()				(PORTA |=  (1 << PA1))					// CS2 Sig:High
#define	cs2_off()				(PORTA &= ~(1 << PA1))					// CS2 Sig:Low
#define	select_read()			(PORTA |=  (1 << PA0))					// R/W* Sig:High
#define	select_write()			(PORTA &= ~(1 << PA0))					// R/W* Sig:Low
#define	select_port_input()		(DDRC &= ~((1 << DDC0) | (1 << DDC1) | (1 << DDC2) | (1 << DDC3) | (1 << DDC4) | (1 << DDC5) | (1 << DDC6) | (1 << DDC7)));		// DC0 -- DC7 Input
#define	select_port_output()	(DDRC |=  ((1 << DDA0) | (1 << DDC1) | (1 << DDC2) | (1 << DDC3) | (1 << DDC4) | (1 << DDC5) | (1 << DDC6) | (1 << DDC7)));		// DC0 -- DC7 Output
#define	output_port				(PORTC)
#define	input_port				(PINC)


// ******** Global Data ********
extern	unsigned int	disp_write_data_pos;					// \pݎMf[^|WV
extern	unsigned int	read_data_pos;							// ǂݏoMf[^JE^[
extern	unsigned int	disp_end_pos;
extern	unsigned char	disp_hex;								// 1:PUi\
extern	unsigned char	disp_moji[21];							// kbc\
extern	unsigned char	n_of_disp_data;							// kbc\鐔̍ő吔iPU͂Sj
extern	unsigned char	n_of_one_line_disp_data;				// Psɕ\f[^
extern	unsigned char	n_of_line;								// kbc\s
extern	unsigned char	n_of_disp_data_pass;					// oߎԗL̂kbc\鐔̍ő吔
extern	unsigned char	n_of_one_line_disp_data_pass;			// oߎԗL̂Psɕ\f[^
extern	unsigned char	set_back_light;							// obNCgnm^nee
extern	unsigned char	icon_data;								// ACRf[^ (rbgΉD0:dr, D1:, D2:, D3:Op)


// ******* Global Function ******
extern	void	disp_lcd_G(unsigned char pos_x, unsigned char pos_y, unsigned char *ucp);
extern	void	disp_clear_lcd_G(void);
extern	void	init_lcd_G(void);
extern	void	disp_direction_signe_lcd_G(void);
extern	void	disp_lcd_icon_G(void);
extern	void	back_light(unsigned char lon);


#ifdef		CHECK_FONT											// tHg`FbN\
// ******* Global Function for Check ******
extern	void	disp_lcd_G_font_check1(void);
extern	void	disp_lcd_G_font_check2(void);
#endif		//CHECK_FONT
