//*****************************************
// AVR ATmega644 Serial Monitor-G
// CPU Clock:8MHz,16MHz,18.432MHz or 20MHz(Compile Option)
// File Name:Setting.c
// VAf[^iqrQRQbjj^[vO
//   iq[Yf[^@is`fgpȂAȂAwIV[^(16MHz)Aɂj
//   i`FbN͂rohdmj
//
//  2013/05/26 New  Taishi ATmega644
//*****************************************
#include	<avr/interrupt.h>
#include	<avr/io.h>
#include	<avr/sleep.h>
#include	<avr/pgmspace.h>

#include	"AVR_ATmega644_G_moni.h"
#include	"Utility.h"
#include	"Serial.h"
#include	"LCD.h"
#include	"Display.h"
#include	"timer.h"

#include	"Setting.h"

unsigned char	pbs_str[CODE_BPS_MAX+1][7] PROGMEM = {
			{'1','2','0','0',' ',' ', 0x00},
			{'2','4','0','0',' ',' ', 0x00},
			{'4','8','0','0',' ',' ', 0x00},
			{'9','6','0','0',' ',' ', 0x00},
			{'1','4','4','0','0',' ', 0x00},
			{'1','9','2','0','0',' ', 0x00},
			{'2','8','8','0','0',' ', 0x00},
			{'3','8','4','0','0',' ', 0x00},
			{'5','7','6','0','0',' ', 0x00},
			{'7','6','8','0','0',' ', 0x00},
			{'1','1','5','2','0','0', 0x00},
			{' ',' ',' ',' ',' ',' ', 0x00},
		};																				// aor\iBPS ɑ΂ enum code_bps Ɠт̕KvLj

unsigned char	data_length_str[CODE_DATA_MAX+1][2] PROGMEM = {
			{'8', 0x00},
			{'7', 0x00},
			{' ', 0x00}
		};																				// f[^\if[^ɑ΂ enum code_data_length Ɠт̕KvLj

unsigned char	parity_str[CODE_PARITY_MAX+1][4] PROGMEM = {
			{'N','O','N', 0x00},
			{'E','V','N', 0x00},
			{'O','D','D', 0x00},
			{' ',' ',' ', 0x00},
		};																				// peB\ipeBɑ΂ enum code_parity Ɠт̕KvLj

unsigned char	end_less_str[CODE_END_MAX+1][10] PROGMEM = {
			{'E','N','D',' ','L','E','S','S',' ', 0x00},
			{'O','N','E',' ','C','Y','C','L',' ', 0x00},
			{'E','r','r',' ','E','N','D',' ',' ', 0x00},
			{'S','T','R',' ','T','R','I','G','-', 0x00},
			{'E','N','D',' ','T','R','I','G','-', 0x00},
			{'T','R','I','G',' ','C','Y','C','-', 0x00},
			{' ',' ',' ',' ',' ',' ',' ',' ',' ', 0x00},
		};																				// GhX\iGhXɑ΂ enum code_end_less Ɠт̕KvLj

unsigned char	off_on_str[CODE_PASS_MAX+1][4] PROGMEM = {
			{'O','F','F', 0x00},
			{'O','N',' ', 0x00},
			{' ',' ',' ', 0x00},
		};																				// oߎԕ\@L enum code_pass_time Ɠт̕KvLj

unsigned char	space_20[] PROGMEM = {"                    "};							// Xy[XQO
unsigned char	str_half_duplex_only[] PROGMEM = {"* Half Duplex Only *"};				// QdʐM\

unsigned char	str_passage_time[] PROGMEM = {"PASSAGE-TIME:"};							// oߎԂ̕\
unsigned char	str_back_light[] PROGMEM = {"Pack-Light:"};								// obNCg̕\

//*****************************************
// ݒf[^̐ݒ
//*****************************************
void	set_setting_data(void)
{

	unsigned char	curs_pos = POS_BPS;
	unsigned char	kesu = 1;
	unsigned char	renzoku;

	tim_sw = 0;
	tim_disp = 0;
	tim_run_led = 0;
	renzoku = 0;

#ifdef		DEBUG_TX
	set_sleep_mode(SLEEP_MODE_IDLE);																// X[vFACh[h
#else		//DEBUG_TX
	set_sleep_mode(SLEEP_MODE_EXT_STANDBY);															// X[vFgX^oC[h
#endif		//DEBUG_TX

	get_pgm_str(&str_passage_time[0]);																// vÖ̕擾
	disp_lcd_G(1,2,disp_moji);																		// oߎ("PASSAGE-TIME:")̕\
	get_pgm_str(&str_back_light[0]);																// vÖ̕擾
	disp_lcd_G(1,3,disp_moji);																		// oߎ("Back-Light:")̕\

	sei();																							// 荞݉
	// [v
	for(;;){
		// ݒf[^J[\\
		if(tim_disp == 0){
			tim_disp = 50;
			kesu ^= 1;
			if(kesu == 1){																			// 
				if( curs_pos == POS_BPS){															// aor̎
					get_pgm_str(&pbs_str[CODE_BPS_MAX][0]);											// vÖ̕("9600  ",)擾
					disp_lcd_G(POS_BPS,0,disp_moji);												// QdʐM\

					if(set_bps == CODE_115200){
						get_pgm_str(&space_20[0]);													// vÖ̕("                ")擾
						disp_lcd_G(POS_BPS,5,disp_moji);											// QdʐM\
					}

					get_pgm_str(&data_length_str[set_data_length][0]);								// vÖ̕("8","7")擾
					disp_lcd_G(POS_DATA,0,disp_moji);												// f[^\

					get_pgm_str(&parity_str[set_parity][0]);										// vÖ̕("NON","EVN","ODD")擾
					disp_lcd_G(POS_PARITY,0,disp_moji);												// peB\

					get_pgm_str(&end_less_str[set_end_less][0]);									// vÖ̕("END LESS",)擾
					disp_lcd_G(POS_END_LESS,1,disp_moji);											// GhX\
					disp_trig_data();																// gKf[^p\

					get_pgm_str(&off_on_str[set_pass_time][0]);										// vÖ̕("ON ","OFF")擾
					disp_lcd_G(POS_PASS_TIME,2,disp_moji);											// oߎԗL\

					get_pgm_str(&off_on_str[set_back_light][0]);									// vÖ̕("ON ","OFF")擾
					disp_lcd_G(POS_BACK_LIGHT,3,disp_moji);											// oߎԗL\

				}else if( curs_pos == POS_DATA){													// f[^̎
					get_pgm_str(&pbs_str[set_bps][0]);												// vÖ̕("9600  ",)擾
					disp_lcd_G(POS_BPS,0,disp_moji);												// QdʐM\

					if(set_bps == CODE_115200){
						get_pgm_str(&str_half_duplex_only[0]);										// vÖ̕("Half Duplex Only")擾
					}else{
						get_pgm_str(&space_20[0]);													// vÖ̕("                ")擾
					}
					disp_lcd_G(POS_BPS,5,disp_moji);												// QdʐM\

					get_pgm_str(&data_length_str[CODE_DATA_MAX][0]);								// vÖ̕(" ")擾
					disp_lcd_G(POS_DATA,0,disp_moji);												// f[^\

					get_pgm_str(&parity_str[set_parity][0]);										// vÖ̕("NON","EVN","ODD")擾
					disp_lcd_G(POS_PARITY,0,disp_moji);												// peB\

					get_pgm_str(&end_less_str[set_end_less][0]);									// vÖ̕("END LESS",)擾
					disp_lcd_G(POS_END_LESS,1,disp_moji);											// GhX\
					disp_trig_data();																// gKf[^p\

					get_pgm_str(&off_on_str[set_pass_time][0]);										// vÖ̕("ON ","OFF")擾
					disp_lcd_G(POS_PASS_TIME,2,disp_moji);											// oߎԗL\

					get_pgm_str(&off_on_str[set_back_light][0]);									// vÖ̕("ON ","OFF")擾
					disp_lcd_G(POS_BACK_LIGHT,3,disp_moji);											// oߎԗL\

				}else if( curs_pos == POS_PARITY){													// peB̎
					get_pgm_str(&pbs_str[set_bps][0]);												// vÖ̕("9600  ",)擾
					disp_lcd_G(POS_BPS,0,disp_moji);												// QdʐM\

					if(set_bps == CODE_115200){
						get_pgm_str(&str_half_duplex_only[0]);										// vÖ̕("Half Duplex Only")擾
					}else{
						get_pgm_str(&space_20[0]);													// vÖ̕("                ")擾
					}
					disp_lcd_G(POS_BPS,5,disp_moji);												// QdʐM\

					get_pgm_str(&data_length_str[set_data_length][0]);								// vÖ̕("8","7")擾
					disp_lcd_G(POS_DATA,0,disp_moji);												// f[^\

					get_pgm_str(&parity_str[CODE_PARITY_MAX][0]);									// vÖ̕("NON","EVN","ODD")擾
					disp_lcd_G(POS_PARITY,0,disp_moji);												// peB\

					get_pgm_str(&end_less_str[set_end_less][0]);									// vÖ̕("END LESS",)擾
					disp_lcd_G(POS_END_LESS,1,disp_moji);											// GhX\
					disp_trig_data();																// gKf[^p\

					get_pgm_str(&off_on_str[set_pass_time][0]);										// vÖ̕("ON ","OFF")擾
					disp_lcd_G(POS_PASS_TIME,2,disp_moji);											// oߎԗL\

					get_pgm_str(&off_on_str[set_back_light][0]);									// vÖ̕("ON ","OFF")擾
					disp_lcd_G(POS_BACK_LIGHT,3,disp_moji);											// oߎԗL\

				}else if( curs_pos == POS_END_LESS){												// GhX̎
					get_pgm_str(&pbs_str[set_bps][0]);												// vÖ̕("9600  ",)擾
					disp_lcd_G(POS_BPS,0,disp_moji);												// QdʐM\

					if(set_bps == CODE_115200){
						get_pgm_str(&str_half_duplex_only[0]);										// vÖ̕("Half Duplex Only")擾
					}else{
						get_pgm_str(&space_20[0]);													// vÖ̕("                ")擾
					}
					disp_lcd_G(POS_BPS,5,disp_moji);												// QdʐM\

					get_pgm_str(&data_length_str[set_data_length][0]);								// vÖ̕("8","7")擾
					disp_lcd_G(POS_DATA,0,disp_moji);												// f[^\

					get_pgm_str(&parity_str[set_parity][0]);										// vÖ̕("NON","EVN","ODD")擾
					disp_lcd_G(POS_PARITY,0,disp_moji);												// peB\

					get_pgm_str(&end_less_str[CODE_END_MAX][0]);									// vÖ̕("END LESS",)擾
					disp_lcd_G(POS_END_LESS,1,disp_moji);											// GhX\
					disp_trig_data();																// gKf[^p\

					get_pgm_str(&off_on_str[set_pass_time][0]);										// vÖ̕("ON ","OFF")擾
					disp_lcd_G(POS_PASS_TIME,2,disp_moji);											// oߎԗL\

					get_pgm_str(&off_on_str[set_back_light][0]);									// vÖ̕("ON ","OFF")擾
					disp_lcd_G(POS_BACK_LIGHT,3,disp_moji);											// oߎԗL\

				}else if( curs_pos == POS_TRIG_DATA){												// gKf[^̎
					get_pgm_str(&pbs_str[set_bps][0]);												// vÖ̕("9600  ",)擾
					disp_lcd_G(POS_BPS,0,disp_moji);												// QdʐM\

					if(set_bps == CODE_115200){
						get_pgm_str(&str_half_duplex_only[0]);										// vÖ̕("Half Duplex Only")擾
					}else{
						get_pgm_str(&space_20[0]);													// vÖ̕("                ")擾
					}
					disp_lcd_G(POS_BPS,5,disp_moji);												// QdʐM\

					get_pgm_str(&data_length_str[set_data_length][0]);								// vÖ̕("8","7")擾
					disp_lcd_G(POS_DATA,0,disp_moji);												// f[^\

					get_pgm_str(&parity_str[set_parity][0]);										// vÖ̕("NON","EVN","ODD")擾
					disp_lcd_G(POS_PARITY,0,disp_moji);												// peB\

					get_pgm_str(&end_less_str[set_end_less][0]);									// vÖ̕("END LESS",)擾
					disp_lcd_G(POS_END_LESS,1,disp_moji);											// GhX\
					disp_lcd_G(POS_TRIG_DATA+1,1,(unsigned char *)"  ");							// gKf[^\

					get_pgm_str(&off_on_str[set_pass_time][0]);										// vÖ̕("ON ","OFF")擾
					disp_lcd_G(POS_PASS_TIME,2,disp_moji);											// oߎԗL\

					get_pgm_str(&off_on_str[set_back_light][0]);									// vÖ̕("ON ","OFF")擾
					disp_lcd_G(POS_BACK_LIGHT,3,disp_moji);											// oߎԗL\

				}else if( curs_pos == POS_PASS_TIME){												// oߎԗL̎
					get_pgm_str(&pbs_str[set_bps][0]);												// vÖ̕("9600  ",)擾
					disp_lcd_G(POS_BPS,0,disp_moji);												// QdʐM\

					if(set_bps == CODE_115200){
						get_pgm_str(&str_half_duplex_only[0]);										// vÖ̕("Half Duplex Only")擾
					}else{
						get_pgm_str(&space_20[0]);													// vÖ̕("                ")擾
					}
					disp_lcd_G(POS_BPS,5,disp_moji);												// QdʐM\

					get_pgm_str(&data_length_str[set_data_length][0]);								// vÖ̕("8","7")擾
					disp_lcd_G(POS_DATA,0,disp_moji);												// f[^\

					get_pgm_str(&parity_str[set_parity][0]);										// vÖ̕("NON","EVN","ODD")擾
					disp_lcd_G(POS_PARITY,0,disp_moji);												// peB\

					get_pgm_str(&end_less_str[set_end_less][0]);									// vÖ̕("END LESS",)擾
					disp_lcd_G(POS_END_LESS,1,disp_moji);											// GhX\
					disp_trig_data();																// gKf[^p\

					get_pgm_str(&off_on_str[CODE_PASS_MAX][0]);									// vÖ̕("ON ","OFF")擾
					disp_lcd_G(POS_PASS_TIME,2,disp_moji);											// oߎԗL\

					get_pgm_str(&off_on_str[set_back_light][0]);									// vÖ̕("ON ","OFF")擾
					disp_lcd_G(POS_BACK_LIGHT,3,disp_moji);											// oߎԗL\

				}else if( curs_pos == POS_BACK_LIGHT){												// obNCgnm^nee̎
					get_pgm_str(&pbs_str[set_bps][0]);												// vÖ̕("9600  ",)擾
					disp_lcd_G(POS_BPS,0,disp_moji);												// QdʐM\

					if(set_bps == CODE_115200){
						get_pgm_str(&str_half_duplex_only[0]);										// vÖ̕("Half Duplex Only")擾
					}else{
						get_pgm_str(&space_20[0]);													// vÖ̕("                ")擾
					}
					disp_lcd_G(POS_BPS,5,disp_moji);												// QdʐM\

					get_pgm_str(&data_length_str[set_data_length][0]);								// vÖ̕("8","7")擾
					disp_lcd_G(POS_DATA,0,disp_moji);												// f[^\

					get_pgm_str(&parity_str[set_parity][0]);										// vÖ̕("NON","EVN","ODD")擾
					disp_lcd_G(POS_PARITY,0,disp_moji);												// peB\

					get_pgm_str(&end_less_str[set_end_less][0]);									// vÖ̕("END LESS",)擾
					disp_lcd_G(POS_END_LESS,1,disp_moji);											// GhX\
					disp_trig_data();																// gKf[^p\

					get_pgm_str(&off_on_str[set_pass_time][0]);										// vÖ̕("ON ","OFF")擾
					disp_lcd_G(POS_PASS_TIME,2,disp_moji);											// oߎԗL\

					get_pgm_str(&off_on_str[2][0]);													// vÖ̕("ON ","OFF")擾
					disp_lcd_G(POS_BACK_LIGHT,3,disp_moji);											// oߎԗL\

				}
			}else{																					// \鎞
				get_pgm_str(&pbs_str[set_bps][0]);													// vÖ̕("9600  ",)擾
				disp_lcd_G(POS_BPS,0,disp_moji);													// QdʐM\

				if(set_bps == CODE_115200){
					get_pgm_str(&str_half_duplex_only[0]);											// vÖ̕("Half Duplex Only")擾
				}else{
					get_pgm_str(&space_20[0]);														// vÖ̕("                ")擾
				}
				disp_lcd_G(POS_BPS,5,disp_moji);													// QdʐM\

				get_pgm_str(&data_length_str[set_data_length][0]);									// vÖ̕("8","7")擾
				disp_lcd_G(POS_DATA,0,disp_moji);													// f[^\

				get_pgm_str(&parity_str[set_parity][0]);											// vÖ̕("NON","EVN","ODD")擾
				disp_lcd_G(POS_PARITY,0,disp_moji);													// peB\

				get_pgm_str(&end_less_str[set_end_less][0]);										// vÖ̕("END LESS",)擾
				disp_lcd_G(POS_END_LESS,1,disp_moji);												// GhX\
				disp_trig_data();																	// gKf[^p\

				get_pgm_str(&off_on_str[set_pass_time][0]);											// vÖ̕("ON ","OFF")擾
				disp_lcd_G(POS_PASS_TIME,2,disp_moji);												// oߎԗL\

				get_pgm_str(&off_on_str[set_back_light][0]);										// vÖ̕("ON ","OFF")擾
				disp_lcd_G(POS_BACK_LIGHT,3,disp_moji);												// oߎԗL\
			}
		}

		//@XCb`
		get_sw();															//@XCb`Ԃ
		if(sw[2] != 0){														// ꂽXCb`L鎞
			if((sw[2] & SW1) != 0){											// rPꂽ
				if( curs_pos == POS_BPS){									// aor̎
					curs_pos = POS_BACK_LIGHT;								// obNCgLɂ
				}else if( curs_pos == POS_DATA){							// f[^̎
					curs_pos = POS_BPS;										// aorɂ
				}else if( curs_pos == POS_PARITY){							// peB̎
					curs_pos = POS_DATA;									// f[^ɂ
				}else if( curs_pos == POS_END_LESS){						// GhX̎
					curs_pos = POS_PARITY;									// peBɂ
				}else if( curs_pos == POS_TRIG_DATA){						// gKf[^̎
					curs_pos = POS_END_LESS;								// GhXɂ
				}else if( curs_pos == POS_PASS_TIME){						// oߎԗL̎
					if((set_end_less == CODE_STR_TRIG)||(set_end_less == CODE_END_TRIG)||(set_end_less == CODE_TRIG_CYCL)){
						curs_pos = POS_TRIG_DATA;							// gKf[^ɂ
					}else{
						curs_pos = POS_END_LESS;							// GhXɂ
					}
				}else if( curs_pos == POS_BACK_LIGHT){						// obNCg̎
					curs_pos = POS_PASS_TIME;								// oߎԗLɂ
				}
				kesu = 1;
				tim_disp = 0;
				renzoku = 0;
			}
			if((sw[2] & SW2) != 0){											// rQꂽ
				if( curs_pos == POS_BPS){									// aor̎
					set_bps++;
					if(CODE_BPS_MAX <= set_bps){							// BPS ͈͊O
						set_bps = CODE_1200;								// BPS_1200
					}
				}else if( curs_pos == POS_DATA){							// f[^̎
					set_data_length++;
					if(CODE_DATA_MAX <= set_data_length){					// f[^ ͈͊O
						set_data_length = CODE_DATA_8;						// Wrbgf[^
					}
				}else if( curs_pos == POS_PARITY){							// peB̎
					set_parity++;
					if(CODE_PARITY_MAX <= set_parity){						// peB ͈͊O
						set_parity = CODE_PARITY_NON;						// peB
					}
				}else if( curs_pos == POS_END_LESS){						// GhX̎
					set_end_less++;
					if(CODE_END_MAX <= set_end_less){						// GhX ͈͊O
						set_end_less = CODE_END_LESS;						// GhX
					}
				}else if( curs_pos == POS_TRIG_DATA){						// gKf[^̎
					trig_data++;
					tim_run_led = 80;
					renzoku = 1;
				}else if( curs_pos == POS_PASS_TIME){						// oߎԗL̎
					set_pass_time++;
					if(CODE_PASS_MAX <= set_pass_time){						// oߎԗL ͈͊O
						set_pass_time = CODE_PASS_TIME_OFF;					// oߎԖ
					}
				}else if( curs_pos == POS_BACK_LIGHT){						// obNCgL̎
					set_back_light++;
					if(2 <= set_back_light){								// obNCgL ͈͊O
						set_back_light = 0;									// obNCg
					}
					back_light(set_back_light);								// Back Light ON/OFF

				}
				kesu = 1;
				tim_disp = 0;
			}
			if((sw[2] & SW3) != 0){											// rRꂽ
				if( curs_pos == POS_BPS){									// aor̎
					curs_pos = POS_DATA;									// f[^ɂ
				}else if( curs_pos == POS_DATA){							// f[^̎
					curs_pos = POS_PARITY;									// peBɂ
				}else if( curs_pos == POS_PARITY){							// peB̎
					curs_pos = POS_END_LESS;								// GhXɂ
				}else if( curs_pos == POS_END_LESS){						// GhX̎
					if((set_end_less == CODE_STR_TRIG)||(set_end_less == CODE_END_TRIG)||(set_end_less == CODE_TRIG_CYCL)){
						curs_pos = POS_TRIG_DATA;							// gKf[^ɂ
					}else{
						curs_pos = POS_PASS_TIME;							// oߎԗLɂ
					}
				}else if( curs_pos == POS_TRIG_DATA){						// gKf[^̎
					curs_pos = POS_PASS_TIME;								// oߎԗLɂ
				}else if( curs_pos == POS_PASS_TIME){						// oߎԗL̎
					curs_pos = POS_BACK_LIGHT;								// obNCgɂ
				}else if( curs_pos == POS_BACK_LIGHT){						// obNCgL̎
					curs_pos = POS_BPS;										// aorɂ
				}
				kesu = 1;
				tim_disp = 0;
				renzoku = 0;
			}
			if((sw[2] & SW4) != 0){											// rSꂽ
				renzoku = 0;
				break;
			}
		}

		if((sw[1] & SW2) != 0){												// rQꑱĂ鎞
			if(tim_run_led == 0){
				if(renzoku == 1){
					trig_data++;											// gKf[^AĕωiAXL[R[hŁ{Pj
					tim_run_led = 10;
					kesu = 1;
					tim_disp = 0;
				}
			}
		}else{
			renzoku = 0;
		}

		sleep_mode();														// X[vڍs

	}
	cli();
}

//*****************************************
// Save Rxd Setting(BPS) Set to disp_moji[]
//*****************************************
void	get_setting_bps(void)
{
	get_pgm_str(&pbs_str[save_set_bps][0]);					// vÖ̕("9600  ",)擾
}

//*****************************************
// Save Rxd Setting(DATA Length) Set to disp_moji[]
//*****************************************
void	get_setting_data_length(void)
{
	get_pgm_str(&data_length_str[save_set_data_length][0]);	// vÖ̕("8","7")擾
}

//*****************************************
// Save Rxd Setting(PARITY) Set to disp_moji[]
//*****************************************
void	get_setting_parity(void)
{
	get_pgm_str(&parity_str[save_set_parity][0]);			// vÖ̕("NON","EVN","ODD")擾
}

//*****************************************
// Save Rxd Setting(END_LESS) Set to disp_moji[]
//*****************************************
void	get_setting_endless_on_off(void)
{
	get_pgm_str(&end_less_str[save_set_end_less][0]);		// vÖ̕("END LESS",)擾

	if((save_set_end_less == CODE_STR_TRIG)||(save_set_end_less == CODE_END_TRIG)||(save_set_end_less == CODE_TRIG_CYCL)){
		wtod_02x(&disp_moji[10],save_trig_data);
		disp_moji[9] = '-';
	}
}

//*****************************************
// Save Rxd Setting(PASS_TIME) Set to disp_moji[]
//*****************************************
void	get_setting_pass_time_on_off(void)
{
	get_pgm_str(&off_on_str[set_pass_time][0]);			// vÖ̕("ON ","OFF")擾
	disp_moji[13] = disp_moji[0];
	disp_moji[14] = disp_moji[1];
	disp_moji[15] = disp_moji[2];
	disp_moji[16] = disp_moji[3];
	get_pgm_str(&str_passage_time[0]);					// vÖ̕擾
	disp_moji[13] = 'O';
}
//*****************************************
// Space20 Set to disp_moji[]
//*****************************************
void	get_space20(void)
{
	get_pgm_str(&space_20[0]);							// vÖ̕("                ")擾
}
