//*****************************************
// AVR ATmega644 Serial Monitor-G
// CPU Clock:8MHz,16MHz,18.432MHz or 20MHz(Compile Option)
// File Name:timer.c
// VAf[^iqrQRQbjj^[vO
//   iq[Yf[^@is`fgpȂAȂAwIV[^(16MHz)Aɂj
//   i`FbN͂rohdmj
//
//  2013/05/26 New  Taishi ATmega644
//*****************************************
#include				<avr/interrupt.h>
#include				<avr/io.h>
#include				<avr/pgmspace.h>


#include				"AVR_ATmega644_G_moni.h"
#include				"Serial.h"
#include				"Ad_conv.h"
#include				"timer.h"

#include				"Utility.h"

volatile unsigned char	tim_led;						// kdc_p^C}[iPOrPʁj
volatile unsigned char	tim_sw;							// XCb`͗p^C}[iPOrPʁj
volatile unsigned int	tim_disp;						// Mf[^\Ԋup^C}[iPOrPʁj
volatile unsigned int	tim_run_led;					// Mf[^擾kdc_ŗp^C}[iPOrPʁj
volatile unsigned int	tim_bat_ad;						// obed`^cl擾Ԋup^C}[iPOrPʁj

volatile unsigned int	wait_i;
volatile unsigned int	wait_j;
volatile unsigned char	wait_us;

unsigned char			sw[3];							// SW[1] Ɍ݂̏ԁAĂ镨'1'̏ԁA SW[2] ɉꂽuԂ'1'̏
unsigned char			old_sw;

unsigned short			passage_1ms;					// PrJE^
unsigned short			passage_1s;						// PbJE^


// ************************************
// Delay 2uS
// t: uS (max 255)
// CPU Clock:16MHz
// ************************************
void delay_2us(unsigned char t)
{
	while(t-- != 0){
		wait_us++;				// 1uS Delay
		wait_us++;				// 1uS Delay
		wait_us++;				// 1uS Delay
		wait_us++;				// 1uS Delay
		wait_us++;				// 1uS Delay
		wait_us++;				// 1uS Delay
	}
}
//***************************
// Wait
//  tm : Wait Time(ms) max. 8000
// CPU Clock:16MHz
//***************************
void	delay_ms(int tm)
{

	tm *= 2;
	for(wait_i = 0; wait_i < tm; wait_i++){
		delay_2us(250);
	}
}
//***************************
// Timer2 Initial
// CPU Clock:8MHz,16MHz or 20MHz
//  10mS Ԋů荞݂ɂ
//***************************
void	timer2_init(void)
{
	TCNT2 = 0;											// Timer2 Count Set to ZERO
	TCCR2A = ((1 << WGM21) | (0 << WGM20));				// A Comper Match, Dont Output Timer2 Signal
	OCR2A  = COUNT_10MS;								// 10mS COUNT
	TCCR2B = ((1 << CS22) | (1 << CS21) | (1 << CS00));	// Timer Start (16MHz/1024= 7812.5Hz, 0.128mS)
	TIMSK2 |= (1 << OCIE2A);							// A Comper Match Interrupt Enable
}
//***************************
// Timer2 Comper Match A Interrupt
// 10ms Interrupt
//***************************
ISR	(TIMER2_COMPA_vect)
{
	if(tim_led != 0){
		tim_led--;
	}

	if(tim_sw != 0){
		tim_sw--;
	}

	if(tim_disp != 0){
		tim_disp--;
	}

	if(tim_run_led != 0){
		tim_run_led--;
	}

	if(tim_bat_ad != 0){
		tim_bat_ad--;
	}

	ad7_set_data();						// A/D 7 Set A/D data to Data Buffer

}
//***************************
// Timer1 Initial
// CPU Clock:8MHz,16MHz or 20MHz
//  Timer1 Not Start
//***************************
void	timer1_init(void)
{
	TCCR1B = 0;						// Timer Stop
	TCNT1 = 0;						// Timer1 Count Set to ZERO
	TCCR1A = 0x00;					// A Comper Match, Dont Output Timer1 Signal
	OCR1A  = COUNT_1MS;				// 1mS ex.8MHz/8=1MHz, 16MHz/8=2MHz, 18.432MHz/8=2.304MHz
	TIMSK1 |= (1 << OCIE1A);		// A Comper Match Interrupt Enable
}
//***************************
// Passage time Clear
//  Count Zero Immediately
//***************************
void	pass_time_clear(void)
{
	TCNT1 = 0;									// Timer1 Count Set to ZERO
	TIFR1 |= (1 << OCF1A);						// Interrupt Req. Flag Clear
	passage_1ms = 0;							// PrJE^O
	passage_1s = 0;								// PbJE^O
}
//***************************
// Passage time start (Use Timer1)
// CPU Clock:8MHz,16MHz or 20MHz
//  Start from Count Zero Immediately
//***************************
void	pass_time_start(void)
{
	TCCR1B = 0;									// Timer Stop
	TCNT1 = 0;									// Timer1 Count Set to ZERO
	passage_1ms = 0;							// PrJE^O
	passage_1s = 0;								// PbJE^O
	TCCR1B = ( (1 << WGM12) | (1 << CS11) );	// Timer Start (clk_io/8)
}
//***************************
// Passage Time stop (Use Timer1)
// CPU Clock:8MHz,16MHz or 20MHz
//  Stop Immediately
//***************************
void	pass_time_stop(void)
{
	TCCR1B = 0;						// Timer Stop
}

//***************************
// Timer1 Comper Match A Interrupt
// 1ms Interrupt
//***************************
ISR	(TIMER1_COMPA_vect)
{
	passage_1ms++;											// PrJE^{P
	if(1000 <= passage_1ms){								// Pbo
		passage_1ms = 0;
		if(passage_1s < 999){								// XXXb̎
			passage_1s++;									// PbJEg{P
		}
	}

}
//***************************
// Get Passage Time
// Return : Passage Time
//
// D0 -- D9 : Value
// D12 -- D15 : Unit
//          0 : uS
//          1 : 10uS
//          2 : 100uS
//          3 : 1mS
//          4 : 10mS
//          5 : 100mS
//          6 : 1S
//          7 : 1S
//***************************
unsigned int get_pass_time(void)
{
	unsigned int	r = 0;

	r = ( ((long)TCNT1 * (long)1000) / (long)COUNT_1MS );	// Get Timer1 Count(uS)
	if(passage_1s == 0){									// Pr̎
		if(passage_1ms == 0){								// Pr̎
			;												//  ^C}[P̒l
		}else if(passage_1ms < 10){							// POr̎
			r /= 10;										// ^C}[P̒lP^PO
			r += (passage_1ms * 100);						// PrJE^̂POO{𑫂
			r |= (1 << 12);									// Unit:10uS
		}else if(passage_1ms < 100){						// POOr̎
			r /= 100;										// ^C}[P̒lP^POO
			r += (passage_1ms * 10);						// PrJE^̂PO{𑫂
			r |= (2 << 12);									// Unit:100uS
		}else{												// Pr̎
			r = passage_1ms;								// PrJE^
			r |= (3 << 12);									// Unit:1mS
		}
	}else{													// Prȏ̎
		if(passage_1s < 10){								// POr̎
			r = passage_1ms/10;								// PrJE^̒lP^PO
			r += (passage_1s * 100);						// PrJE^̂POO{𑫂
			r |= (4 << 12);									// Unit:10mS
		}else if(passage_1s < 100){							// POOr̎
			r = passage_1ms/100;							// PrJE^̒lP^POO
			r += (passage_1s * 10);							// PrJE^̂PO{𑫂
			r |= (5 << 12);									// Unit:100mS
		}else{												// POOOr̎
			r = passage_1s;									// PrJE^
			r |= (6 << 12);									// Unit:1S
		}
	}
	return(r);
}

//***************************
// Get Passage Time & Clear
// Return : Passage Time
//
// D0 -- D9 : Value
// D12 -- D15 : Unit
//          0 : uS
//          1 : 10uS
//          2 : 100uS
//          3 : 1mS
//          4 : 10mS
//          5 : 100mS
//          6 : 1S
//          7 : 1S
//***************************
unsigned int get_pass_time_with_clear(void)
{
	unsigned int	r = 0;
	unsigned int	t;
	unsigned int	us;
	unsigned int	ms;
	unsigned int	s;

	t = TCNT1;											// Get Timer1 Count(uS)
	ms = passage_1ms;
	s = passage_1s;

	TCNT1 = 0;											// Timer1 Count Set to ZERO
	TIFR1 |= (1 << OCF1A);								// Interrupt Req. Flag Clear
	passage_1ms = 0;									// PrJE^O
	passage_1s = 0;										// PbJE^O

	us = ( ((long)t * (long)1000) / (long)COUNT_1MS );	// Get Timer1 Count(uS)
	if(s == 0){											// Pr̎
		if(ms == 0){									// Pr̎
			r = us;										//  ^C}[P̒l
		}else if(ms < 10){								// POr̎
			r = us/10;									// ^C}[P̒lP^PO
			r += (ms * 100);							// PrJE^̂POO{𑫂
			r |= (1 << 12);								// Unit:10uS
		}else if(ms < 100){								// POOr̎
			r = us/100;									// ^C}[P̒lP^POO
			r += (ms * 10);								// PrJE^̂PO{𑫂
			r |= (2 << 12);								// Unit:100uS
		}else{											// Pr̎
			r = ms;										// PrJE^
			r |= (3 << 12);								// Unit:1mS
		}
	}else{												// Prȏ̎
		if(s < 10){										// POr̎
			r = ms/10;									// PrJE^̒lP^PO
			r += (s * 100);								// PrJE^̂POO{𑫂
			r |= (4 << 12);								// Unit:10mS
		}else if(s < 100){								// POOr̎
			r = ms/100;									// PrJE^̒lP^POO
			r += (s * 10);								// PrJE^̂PO{𑫂
			r |= (5 << 12);								// Unit:100mS
		}else{											// POOOr̎
			r = s;										// PrJE^
			r |= (6 << 12);								// Unit:1S
		}
	}
	return(r);
}

//***************************
//@XCb`Ԃ
// SW[1] Ɍ݂̏ԁAĂ镨'1'̏
// SW[2] ɉꂽuԂ'1'̏
//  Timer1 ̊荞݂gpĂԂKv
//***************************
void	get_sw(void)
{
	unsigned char	uc;

	if(tim_sw == 0){
		tim_sw = 3;											// ROrԊu
		uc = ((~PINB) & (SW1 | SW2 | SW3 | SW4 | SW5));		// ]ăXCb`f[^擾
		if (old_sw == uc){									// OƓf[^̎
			sw[0] = sw[1];
			sw[1] = uc;
			sw[2] = ((sw[0] ^ sw[1]) & sw[1]);				// ꂽXCb`f[^
		}else{
			sw[2] = 0;
		}
		old_sw = uc;										// Of[^ɓ
	}else{
		sw[2] = 0;
	}
}
