//*****************************************
// AVR ATmega644 Serial Monitor-G
// CPU Clock:8MHz,16MHz,18.432MHz or 20MHz(Compile Option)
// File Name:timer.h
//  wb_[t@C
//
//  2013/05/26 New  Taishi ATmega644
//*****************************************

#if		CPU_CLOCK == 20								// 20MHz
  // Xtal:20MHz
  #define		COUNT_10MS		195					// 10mS at 20MHz/1024(19531.25Hz) vZ195.3125
  #define		COUNT_1MS		2500				// 1mS at 20MHz/8(2,5MHz)
#else
  #if	CPU_CLOCK == 18								// 18.432MHz
	// Xtal:18.432MHz
	#define		COUNT_10MS		180 				// 10mS at 18.432MHz/1024(18000Hz) vZ156.25
    #define		COUNT_1MS		2304				// 1mS at 18.432MHz/8(2.304MHz)
  #else
    #if	CPU_CLOCK == 16								// 16MHz
	  // Xtal:16MHz
	  #define	COUNT_10MS		156					// 10mS at 16MHz/1024(15625Hz) vZ156.25
      #define	COUNT_1MS		2000				// 1mS at 16MHz/8(2MHz)
    #else
	  // Xtal:8MHz									// 8MHz
	  #define	COUNT_10MS		78					// 10mS at 8MHz/1024(7812.5Hz) vZ78.125
      #define	COUNT_1MS		1000				// 1mS at 8MHz/8(1MHz)
    #endif
  #endif
#endif

// XCb`
#define		SW1			(1 << PINB0)							// XCb`P ( <-- )
#define		SW2			(1 << PINB1)							// XCb`Q ( ASC/HEX )
#define		SW3			(1 << PINB2)							// XCb`R ( --> )
#define		SW4			(1 << PINB3)							// XCb`S ( START/STOP )
#define		SW5			(1 << PINB4)							// XCb`T ( SAVE )

extern	volatile unsigned char	tim_led;						// kdc_p^C}[iPOrPʁj
extern	volatile unsigned char	tim_sw;							// XCb`͗p^C}[iPOrPʁj
extern	volatile unsigned int	tim_disp;						// Mf[^\Ԋup^C}[iPOrPʁj
extern	volatile unsigned int	tim_run_led;					// Mf[^擾kdc_ŗp^C}[iPOrPʁj
extern	volatile unsigned int	tim_bat_ad;						// obed`^cl擾Ԋup^C}[iPOrPʁj
extern	unsigned char			sw[3];

extern	unsigned short			passage_1ms;					// PrJE^
extern	unsigned short			passage_1s;						// PbJE^

extern	void	delay_2us(unsigned char t);
extern	void	delay_ms(int tm);
extern	void	timer2_init(void);
extern	void	get_sw(void);
extern	void	timer1_init(void);
extern	void	pass_time_clear(void);
extern	void	pass_time_start(void);
extern	void	pass_time_stop(void);
extern	unsigned int get_pass_time_with_clear(void);
extern	unsigned int get_pass_time(void);
